"""
2023: 03: 19, 21 

Toto je hlavni skript, ktery resi ulohu 
optimalizace postupu napojovani komponent v rozpadle silnicni siti. 

Pred spustenim tohoto skriptu je potreba ve skriptu pomocne.py 
nahore vyplnit promenne sit, situace, ktere specifikuji 
cestu ke vstupnim datovym souborum. 

V tomto skriptu je mozne nastavit parametry resice, 
viz vstupniParametry, parametry. 
"""


import pomocne as pm 
import reseniM as aco 
import numpy as np 
import time



casyCG = pm.casyCG 
startyCG = pm.startyCG 
poctyTymuVeStanicich = np.array([1]*len(startyCG)) 
vystupniAdresar = "C:\\Prilohy\\Kody\\vysledky\\" 

vstupniParametry = {} 
vstupniParametry["pocetKolonii"] = 1 
vstupniParametry["iterLimit"] = 1000 
vstupniParametry["zpusobVyberuMravence"] = 'vm2' 
vstupniParametry["zlepsovaciAlgoritmus"] = 'opt2' 

parametry = aco.pripravParametry(vstupniParametry, casyCG, poctyTymuVeStanicich) 



# Proces reseni ulohy: 

zaznamnik = [] 
t = time.time() 
(reseni_bs, variabilitaFeromonu) = aco.MMAS(casyCG, startyCG, poctyTymuVeStanicich, parametry, zaznamnik) 
trvalo = time.time() - t 
print('Vypocet trval: ' + str(trvalo) + ' sekund.') 



# Serazeni reseni od nejlepsich po nejhorsi, ulozeni a nakresleni: 

def prezentace(): 
    tabulkaCeny = [] 
    tabulkaDobyPraci = [] 
    for r in zaznamnik: 
        dobyPraci = aco.cenyTras(r) 
        tabulkaCeny.append(pm.cenaQ3(dobyPraci)) 
        tabulkaDobyPraci.append(dobyPraci) 
    tabulkaCeny = np.array(tabulkaCeny) 
    tabulkaDobyPraci = np.array(tabulkaDobyPraci) 
    kdemin = np.argmin(tabulkaCeny[:,0]) 
    
    # Nejlepsi nalezene reseni nad uzly site CG: 
    reseniCG = zaznamnik[kdemin] 
    nrcg = np.array([str(reseniCG[0]),str(reseniCG[1])]) 
    pm.ulozeni(nrcg, vystupniAdresar, "reseniCGnn") 
    
    # Nejlepsi nalezene reseni nad uzly puvodni site G: 
    reseniG = pm.adapterReseni_CG_G(reseniCG) 
    nrg = np.array([str(reseniG[0]),str(reseniG[1])]) 
    pm.ulozeni(nrg, vystupniAdresar, "reseniGnn") 
    
    # Nejlepsi nalezene reseni ve forme permutace blokaci pro kazdou cetu: 
    reseniPB = pm.poradiBlokacizReseni(reseniCG) 
    nrp = [] 
    for p in reseniPB: 
        nrp.append(str(p)) 
    pm.ulozeni(nrp, vystupniAdresar, "reseniPBnn") 
    
    # Ceny reseni od nejlepsi po nejhorsi. 
    (tabulkaSerazena, taidxs) = pm.mujLexSort(tabulkaCeny) 
    palivo = np.sum(tabulkaSerazena,axis=1).reshape(tabulkaSerazena.shape[0],1) 
    tabulkaSynopticky = np.hstack((tabulkaSerazena, palivo))
    pm.ulozeni(tabulkaSynopticky, vystupniAdresar, "ceny_vsechny") 
    cenyVsechny = tabulkaSynopticky 
    
    # Zde zustava jasne, ktera ceta jak dlouho pracovala. 
    tabulkaDobyPraciSerazena = tabulkaDobyPraci[taidxs,:].copy() 
    pm.ulozeni(tabulkaDobyPraciSerazena, vystupniAdresar, "dobyPraci_vsechny") 
    dobyPraciVsechny = tabulkaDobyPraciSerazena 
    
    # Reseni ve forme permutaci blokaci. Serazena dle ceny vzestupne. 
    zaznamnikSerazen = [] 
    for i in range(len(taidxs)): 
        reseni_tmp = zaznamnik[taidxs[i]] 
        pbr = pm.poradiBlokacizReseni(reseni_tmp) 
        zaznamnikSerazen.append(str(pbr)) 
    zaznamnikSerazen = np.array(zaznamnikSerazen) 
    pm.ulozeni(zaznamnikSerazen, vystupniAdresar, "reseniPB_vsechna") 
    
    # Prevod reseniCG na reseniG a nakresleni reseniG. 
    pm.kresliKomponenty(vystupniAdresar+'komponenty') 
    pm.kresliReseni(reseniCG, vystupniAdresar+'reseniGnn') 
    
    return (reseniCG, reseniG, reseniPB, cenyVsechny, dobyPraciVsechny, tabulkaCeny) 



# # Ulozeni vysledkuu: 
# (reseniCG, reseniG, reseniPB, cenyVsechny, dobyPraciVsechny, cenyPuvodni) = prezentace() 

# import matplotlib.pyplot as plt
# x = np.arange(parametry["iterLimit"])
# plt.plot(x, variabilitaFeromonu, linewidth=1) 

