# -*- coding: utf-8 -*-
"""
2022:10: 25, 
2023:02: 10, 19, 
2023:03: 19, 20 
Pomocne funkce. 
"""



from uloha import uloha 
import numpy as np 
import math as mm
import pandas as pd
import os
import networkx as nx
from PIL import Image 
import matplotlib.pyplot as plt



### Zvolime ulohu zadanim adresaruu 
### ============================================================== 
sit = "C:\\Prilohy\\Ulohy\\sit001" 
situace = "k11d03" 
### ============================================================== 
# Adresare musi byt ve tvaru:   sit\situace, napriklad:  
# C:\Prilohy\Ulohy\sit001\k11d03 

# Nahrajeme ulohu OPRBRN 
promenne = uloha(sit, situace) 

xy = promenne["xy"] 
uzly = promenne["uzly"] 
hrany = promenne["hrany"] 
starty = promenne["starty"] 
blokace = promenne["blokace"] 
doby_oprav = promenne["doby_oprav"] 
legendaCG = promenne["legendaCG"] 
casyCG = promenne["casyCG"] 
blokaceCG = promenne["blokaceCG"] 
startyCG = promenne["startyCG"] 
uzlyKomp = promenne["uzlyKomp"] 
uzlyKMG = promenne["uzlyKMG"] 
hranyKMG = promenne["hranyKMG"] 
komponent = len(np.unique(uzlyKomp)) 
del promenne 

# Ted uz mame kompletni data. 
# hranyKMG [odKomp1, doKomp2, dobaOpravy, idBlokaceCG] 


barvy1 = ['#ffffff','#ffffaa','#ffff55','#ffaaff','#ffaaaa','#ffaa55','#ff55ff','#ff55aa','#ff5555',
         '#aaffff','#aaffaa','#aaff55','#aaaaff','#aaaaaa','#aaaa55','#aa55ff','#aa55aa','#aa5555',
         '#55ffff','#55ffaa','#55ff55','#55aaff','#55aaaa','#55aa55','#5555ff','#5555aa','#555555']
barvy2 = ['#ffff33','#ff9999','#ff9944','#ff55bb','#ff1111',
          '#aaff55','#aaaaaa','#aaaa55','#aa33aa','#aa5511',
         '#55ffff','#55ff55','#55aaaa','#22aa22','#3333ff']
barvy1 = np.array(barvy1)
barvy2 = np.array(barvy2)
barvy3 = barvy2[np.array([4,13,14,3,0,10,9,11,12,2,5,6,1,7,8])] 


# Puvodni sit a rozpadla sit: 
puvodniSit = nx.Graph() 
rozpadlaSit = nx.Graph() 
uattr = []
hattrse = []
hattrse2 = []
for i in range(0,len(xy)): 
    if (i in legendaCG[:,0]): 
        icg = legendaCG[legendaCG[:,0]==i,1][0] 
    else: 
        icg = None 
    vlastnosti = {"xy": xy[i,:], "obyvatel": uzly[i,1], "cg": icg} 
    uattr.append((i, vlastnosti))
for i in range(0,len(hrany)): 
    prujezdna = not(i in blokace) 
    vlastnosti = {"sekund": hrany[i,2], "prujezdna": prujezdna, 
                  "id_hrany": i} 
    hattrse.append((hrany[i,0], hrany[i,1], vlastnosti)) 
    if prujezdna: 
        vlastnosti = {"sekund": hrany[i,2], "id_hrany": i} 
        hattrse2.append((hrany[i,0], hrany[i,1], vlastnosti)) 
puvodniSit.add_nodes_from(uattr)
puvodniSit.add_edges_from(hattrse) 
rozpadlaSit.add_nodes_from(uattr)
rozpadlaSit.add_edges_from(hattrse2) 
del uattr, hattrse, hattrse2 

def generujCesty(): 
    cestyvgmezicg = {} 
    cestyvcgmezicg = {} 
    for i in (legendaCG[:,0].tolist()): # jen od uzluCG 
        cesty = nx.shortest_path(puvodniSit, source=i, target=None, 
                                  weight="sekund", method="dijkstra") 
        odnekuddocg = {} 
        odnekuddocgvcg = {} 
        for j in (legendaCG[:,0].tolist()): 
            odnekuddocg[j] = cesty[j] 
            cestacg = [] 
            for k in cesty[j]: 
                ucg = puvodniSit._node[k]['cg'] 
                if not(ucg is None): 
                    cestacg.append(ucg) 
            odnekuddocgvcg[cestacg[-1]] = cestacg.copy() 
        cestyvgmezicg[i] = odnekuddocg 
        ucg = puvodniSit._node[i]['cg']
        cestyvcgmezicg[ucg] = odnekuddocgvcg 
    return (cestyvgmezicg, cestyvcgmezicg) 

(CESTY, CESTY_CG) = generujCesty() 

def generujPrislusnostHranKomponentam(): 
    S = [rozpadlaSit.subgraph(c).copy() for c in nx.connected_components(rozpadlaSit)] 
    hranyKomponenty = [] 
    for i in range(len(S)): 
        hrk = [] 
        for edge in S[i].edges: 
            hrk.append([edge[0], edge[1]]) 
        hrk = np.array(hrk) 
        ukaz = np.in1d(legendaCG[:,0], np.unique(hrk)) 
        znacky = np.unique(legendaCG[ukaz,2]) 
        if len(znacky)==0:  # samotny uzel je komponenta 
            continue
        sloup = np.array([[znacky[0]]*hrk.shape[0]]) 
        sloup = sloup.transpose() 
        hrk = np.hstack((hrk, sloup)) 
        hrk = hrk.tolist() 
        hranyKomponenty.extend(hrk) 
    hranyKomponenty = np.array(hranyKomponenty) 
    return hranyKomponenty 

hranyKomponenty = generujPrislusnostHranKomponentam() 



# Kodovani reseni. Libovolna reseni. 

def nahodneReseni(pocetUzluCG:int, startyCG:np.ndarray, blokaceCG:np.ndarray): 
    cguzly = np.arange(pocetUzluCG).tolist() 
    trasy = []  # kazdy tym dostane prave jednu trasu 
    for s in startyCG: 
        trasy.append([s]) 
        cguzly.remove(s) 
    N2 = len(cguzly) 
    # N3 je pocet uzlu, ktere vyberu z cguzly a rozdelim do tras 
    N3 = np.random.randint(mm.floor(N2/4), mm.ceil(3*N2/4)) 
    N4 = len(startyCG) 
    for i in range(N3): 
        doKtereTrasy = np.random.randint(N4) 
        idu = np.random.randint(0, N2) 
        cguzel = cguzly.pop(idu) 
        trasy[doKtereTrasy].append(cguzel) 
        N2 = len(cguzly) 
    indikace = []  # hran, ktere m-ty tym opravi (jsou-li zablokovane) 
    for i in range(len(trasy)): 
        trasa = trasy[i] 
        opravit = [] 
        for j in range(len(trasa)-1): 
            u1 = trasa[j] 
            u2 = trasa[j+1] 
            shodne = np.logical_or(\
                np.logical_and(blokaceCG[:,0]==u1, blokaceCG[:,1]==u2), \
                np.logical_and(blokaceCG[:,1]==u1, blokaceCG[:,0]==u2)) 
            if any(shodne): 
                opravit.append(np.random.randint(0,2)) 
            else: 
                opravit.append(0) 
        indikace.append(opravit) 
    return (trasy, indikace) 

def adapterReseni_CG_G(reseni): 
    """ Tohle je zde pro presnejsi nakresleni tras. """
    seznamTrasCG = reseni[0]
    seznamSeznamuOpravCG = reseni[1]
    seznamTras = [] 
    seznamSeznamuOprav = [] 
    m = len(seznamTrasCG) 
    for i in range(m): 
        trasaCG = seznamTrasCG[i] 
        trasaCG = np.array(trasaCG) 
        trasaG = legendaCG[trasaCG,0]  # preklad 
        trasa = []   # se vsemi mezilehlymi uzly v G 
        trasa.append(trasaG[0]) 
        praceCG = seznamSeznamuOpravCG[i] 
        prace = []   # pro puvodni sit G 
        for j in range(len(praceCG)): 
            if praceCG[j]==1: 
                trasa.append(trasaG[j+1]) 
                prace.append(1) 
            else:  # praceCG[j]==0 
                cesta = CESTY[trasaG[j]][trasaG[j+1]] 
                trasa.extend(cesta[1:])
                prace.extend([0]*(len(cesta)-1)) 
        seznamTras.append(trasa) 
        seznamSeznamuOprav.append(prace)
    return (seznamTras, seznamSeznamuOprav) 



# Cenove funkce. 

def cenyTras(casyCG:np.ndarray, reseni:tuple, blokaceCG:np.ndarray): 
    """ Vraci vektor celociselnych cen tras. 
    reseni = ([trasa,...], [opravy,...], ...) 
    Vektor trasa zacina i konci stejnym cislem 
    a je o jedno delsi, nez vektor opravy. """ 
    trasy = reseni[0] 
    indikaceOprav = reseni[1] 
    m = len(trasy) 
    soucty = [0] * m 
    for j in range(m): 
        trasa = trasy[j] 
        opravy = indikaceOprav[j] 
        for i in np.arange(len(opravy)): 
            d = trasa[i] 
            p = trasa[i+1] 
            soucty[j] += int(casyCG[d,p]) 
            if opravy[i] == 1: 
                shodne = np.logical_or(\
                    np.logical_and(blokaceCG[:,0]==d, blokaceCG[:,1]==p), \
                    np.logical_and(blokaceCG[:,1]==d, blokaceCG[:,0]==p)) 
                if any(shodne): 
                    soucty[j] += int(blokaceCG[shodne,2]) 
    return np.array(soucty) 

def cenaQ1(ceny_tras:list): 
    """Soucet dob praci vsech cet. """ 
    return sum(ceny_tras) 

def cenaQ2(ceny_tras:list): 
    """Nejdelsi doba ze vsech dob praci cet. """ 
    return max(ceny_tras) 

def cenaQ3(ceny_tras:list): 
    """Sestupne razene doby praci cet. """ 
    ab = np.array(ceny_tras) 
    return ab[ab.argsort()[::-1]].tolist() 

def delkaTrasy(ceny:np.ndarray, trasa:list): 
    cesta = np.array(trasa) 
    return sum(ceny[cesta[0:-1],cesta[1:]]) 

def delkyTras(ceny:np.ndarray, trasy:list): 
    m = len(trasy) 
    soucty = [0] * m 
    for j in range(m): 
        trasa = trasy[j] 
        soucty[j] = delkaTrasy(ceny, trasa) 
    return soucty

def poctyUzluNaTrasach(zaznamnik): 
    tabulka = [] 
    m = len(zaznamnik[0][0]) 
    for i in range(len(zaznamnik)): 
        vektor = [] 
        for j in range(m): 
            vektor.append(len(zaznamnik[i][0][j])) 
        tabulka.append(vektor) 
    tabulka = np.array(tabulka) 
    return tabulka 

def ukazOpraveneHrany(zaznamnik): 
    tabulka = [] 
    m = len(zaznamnik[0][1]) 
    for i in range(len(zaznamnik)): 
        vektor = [] 
        for j in range(m): 
            for k in range(len(zaznamnik[i][1][j])): 
                if (zaznamnik[i][1][j][k]==1): 
                    vektor.append( kodzHranyCG(zaznamnik[i][0][j][k:(k+2)]) ) 
        tabulka.append(vektor) 
    maximDelka = 0  
    for i in range(len(tabulka)): 
        maximDelka = max(maximDelka, len(tabulka[i])) 
    for i in range(len(tabulka)): 
        if len(tabulka[i])<maximDelka: 
            tabulka[i].extend([-1]*(maximDelka - len(tabulka[i])))
    tabulka = np.array(tabulka) 
    return tabulka 



# Lexikograficke porovnavani m-tic neserazenych cen. 

def mensiLexikograficky(vec1:np.ndarray, vec2:np.ndarray): 
    """
    Vstupy: 
        vec1, vec2... stejne dlouhe neserazene vektory (nebo seznamy, list)
    Prace: 
        Zjisti, ktery z argumentu je po sestupnem serazeni 
        mensi v lexikografickem usporadani a vrati ten mensi, 
        ale neserazeny. 
    Vystupy: 
        viz Prace. 
    """
    if not(type(np.array(vec1)) == np.ndarray): 
        vec1 = np.array(vec1) 
    if not(type(np.array(vec2)) == np.ndarray): 
        vec2 = np.array(vec2) 
    w1 = vec1[vec1.argsort()[::-1]] 
    w2 = vec2[vec2.argsort()[::-1]] 
    n = max(len(w1), len(w2)) 
    i = 0 
    p = w1[i] 
    q = w2[i] 
    while (p == q) and (i < n): 
        p = w1[i] 
        q = w2[i]
        i += 1 
    if (p < q): 
        return vec1 
    else: 
        return vec2 

def mujLexSort(vstupniTabulka): 
    """ Vraci novou tabulku, ktera vznikne lexikografickym 
    vzestupnym serazenim vstupni tabulky a indexy, kterymi 
    lze vstupni tabulku seradit. """ 
    pocetSloupcu = vstupniTabulka.shape[1] 
    tabulka = vstupniTabulka.transpose() 
    tabulka = tabulka[np.arange(pocetSloupcu-1,-1,-1),:] 
    idxs = np.lexsort(tabulka, axis=0) 
    tabulka = vstupniTabulka[idxs,:] 
    return (tabulka, idxs) 



# Kontrola pripustnosti daneho reseni 

def jePripustne(reseni:tuple): 
    """
    Vystup: 
        Vystupem je seznam seznamuu cisel komponent, tzv. vnejsi seznam. 
        Ty komponenty, ktere byly spojeny, jsou spolu v jednom seznamu, 
        ve vnitrnim seznamu. Vnejsi seznam se sklada z vnitrnich seznamuu. 
        Pokud byly vsechny komponenty propojeny do jedne, obsahuje vnejsi 
        seznam pouze jeden vnitrni seznam. 
    """
    znacky = legendaCG[:,0:3].copy() 
    trasy = reseni[0] 
    indikaceOprav = reseni[1] 
    m = len(trasy) 
    for i in range(m): 
        trasa = trasy[i] 
        opravy = indikaceOprav[i] 
        opravy.append(0)  # hranu z posledniho do prvniho uzlu neopravujeme 
        n = len(trasa) 
        for j in range(n): 
            p = -1 
            q = -1 
            if j<(n-1): 
                p = j 
                q = j+1 
            else: 
                p = n-1 
                q = 0 
            ucg1 = trasa[p] 
            ucg2 = trasa[q] 
            # kontrola, zda hrana [ucg1,ucg2] je urcena k oprave 
            opravitAktualniHranu = (opravy[j] == 1) 
            # kontrola, zda hrana [ucg1,ucg2] je zablokovana 
            jeBlokAktualniHrana = np.logical_or(\
                np.logical_and(blokaceCG[:,0]==ucg1, blokaceCG[:,1]==ucg2), \
                np.logical_and(blokaceCG[:,1]==ucg1, blokaceCG[:,0]==ucg2) \
            )
            # pokud ano, zjistit, ktere komponenty spojuje 
            if (any(jeBlokAktualniHrana) and opravitAktualniHranu): 
                k1 = znacky[znacky[:,1]==ucg1, 2] 
                k2 = znacky[znacky[:,1]==ucg2, 2] 
                # spojene komponenty patri do stejne mnoziny 
                znacky[znacky[:,2]==k1, 2] = k2 
    # pokud bude komponent vice, nez jedna, je reseni nepripustne 
    # ale radeji vratit mnozinu mnozin komponent, bo to rika vic 
    usebe = znacky[:,2]
    komponenty = legendaCG[:,2].copy()
    usebeSet = set(usebe.tolist()) 
    vystup = [] 
    for zn in usebeSet: 
        cosi = list(set(komponenty[usebe == zn].tolist())) 
        vystup.append(cosi)
    return vystup    # if len(vystup)==1:  "reseni je pripustne" 



"""
Budu pracovat nad komponentovym multigrafem KMG, az ho pripravim. 

Zatim mam: hranyKMG [k1 k2 Tr idbl] 
  blokace i doby_oprav i blokaceCG i hranyKMG   si odpovidaji svymi radky. 
idbl je index blokace v blokace i v blokaceCG od 0 v.c. do len(blokace) bez. 
hranyKMG [k1 k2], ktere jsou nekolikanasobne se opakujici, od sebe odlisim 
poradovym cislem blokace idbl, idbl = hranyKMG[:,3]. 
k1, k2 jsou cisla komponent. 

Zkopiruju a Preusporadam hranyKMG, aby se v nem dvojice [k1 k2] neopakovaly 
a tyto unikatni hrany [k1 k2] ohodnotim dvojici seznamuu (liCas, liBlo), kde 
liCas je seznam vzestupne razenych dob oprav komponenty a 
liBlo je cislo blokace mezi k1 a k2, ktere odpovida dobe opravy z 1. seznamu. 

Vystupni KMG bude trojice seznamuu - (seznam hran. seznam seznamuu dob oprav, 
                                      seznam seznamuu id blokacii) 
Kazda hrana [k1 k2] je ohodnocena dvema seznamy - seznamem dob oprav 
a seznamem id blokaci. 
"""
def utvorMultigraf(vcetneDobJizd = False): 
    # hranyKMG musi byt nahrano. utvorMultigraf() je vyuziva. 
    n = max(hranyKMG[:,0:2].ravel())+1 
    hranyKMGm = hranyKMG.copy() 
    hranyKMGm[:,2] += casyCG[blokaceCG[:,0], blokaceCG[:,1]] 
    listHran = [] 
    listListuCasu = [] 
    listListuIdBlokaci = [] 
    for k1 in range(n-1): 
        for k2 in range(k1,n): 
            shodne = np.logical_or(\
                np.logical_and(hranyKMG[:,0]==k1, hranyKMG[:,1]==k2), \
                np.logical_and(hranyKMG[:,1]==k1, hranyKMG[:,0]==k2)) 
            if any(shodne): 
                if vcetneDobJizd: 
                    liCas = hranyKMGm[shodne,2] 
                else: 
                    liCas = hranyKMG[shodne,2] 
                liBlo = hranyKMG[shodne,3] 
                cars = liCas.argsort() 
                liCas = liCas[cars].tolist()  # vzestupne razeni dob oprav 
                liBlo = liBlo[cars].tolist() 
                listHran.append([k1, k2]) 
                listListuCasu.append(liCas) 
                listListuIdBlokaci.append(liBlo) 
    multigraf = (listHran, listListuCasu, listListuIdBlokaci) 
    return multigraf 
Mgr_O = utvorMultigraf()        # <- odtud odvodime kostry nebo 
Mgr_OJ = utvorMultigraf(True)   # <- odtud odvodime kostry 



def vyberGraf(multigraf, smer): 
    """ 
    Vstupy: 
        multigraf... trojice seznamu (li1, li2, li3) 
            li1... seznam dvojic [k1 k2] cisel komponent spolu sousedicich 
            li2... seznam seznamuu dob oprav blokacii delicich k1 od k2 
            li3... seznam id blokaci, ktere od sebe deli k1 a k2 
        smer... seznam indexu urcujicich, kterou hranu z multihrany vybrat 
    Prace: 
        V multigrafu jsou nasobne hrany, tzv multihrany. 
        Tato funkce z kazde multihrany vybere prave jednu hranu. 
        Vyber je urcen vstupnim seznamem smer. 
    Vystupy: 
        graf... seznam ctveric [k1 k2 cas_opravy id_blokace] 
        Vystupni graf je podgrafem vstupniho multigrafu. 
    """
    liuzuz = multigraf[0] 
    liliCas = multigraf[1] 
    liliBlo = multigraf[2] 
    graf = [] 
    pmh = len(liliCas)   # pocet multihran 
    for i in range(pmh): 
        s = smer[i] % len(liliCas[i]) 
        graf.append([liuzuz[i][0], liuzuz[i][1], 
                     liliCas[i][s], liliBlo[i][s]]) 
    graf = np.array(graf) 
    return graf 



# Generuj kostry KomponentovehoMultiGrafu. 

def najdiKostru(graf:np.ndarray, tabuList:list): 
    """
    Vstupy: 
        graf... seznam ctveric [k1 k2 ohodnoceniHrany dalsiInfo] 
            Vstupni graf musi byt souvisly, jinak se funkce nezastavi. 
        tabuList... seznam indexuu, hran v posloupnosti Q (viz Prace), 
            ktere zakazeme algoritmu hledani nejlevnejsi kostry pouzit. 
            Muze byt i prazdny, []. 
    Prace: 
        Pro vypocet nejlevnejsi kostry pouzije Boruvkuv(1926)-Kruskaluv(1956) 
        algoritmus. Ostatni kostry ziskame modifikaci tohoto (BKA) algoritmu. 
        BKA seradi hrany grafu vzestupne podle jejich ohodnoceni, cimz vznikne 
        posloupnost Q, posloupnost hran. Pokud je tabuList neprazdny, 
        jsou z Q vyrazeny cleny s indexy uvedenymi v tabuListu a BKA 
        hleda nejlevnejsi kostru v takto modifikovanem grafu. 
        Pokud je tabuList prazdny [], BKA hleda nejlevnejsi kostru zadaneho graafu. 
    Vystupy: 
        Kostra grafu graf. V pripade tabuList=[] nejlevnejsi kostra grafu graf. 
    """
    serazeny = graf[np.argsort(graf[:,2]),:] 
    if tabuList!=None: 
        if len(tabuList)>0: 
            nechat = np.array([True] * serazeny.shape[0]) 
            nechat[np.array(tabuList)] = False 
            serazeny = serazeny[nechat,:] 
    # hledani nejlevnejsi kostry (variace na BKA) 
    indexyKostry = [] 
    znacky = serazeny[:,0:2].copy() 
    pocetKomponent = len(np.unique(znacky))  
    i = 0 
    while pocetKomponent > 1: 
        if (znacky[i,0] != znacky[i,1]): 
            # spojeni dvou ruznych komponent 
            indexyKostry.append(i)  
            # jejich oznaceni stejnou znackou 
            znacka = znacky[i,0] 
            znacky[znacky[:,0]==znacky[i,1],0] = znacka 
            znacky[znacky[:,1]==znacky[i,1],1] = znacka 
        pocetKomponent = len(np.unique(znacky)) 
        i += 1 
    kostra = serazeny[np.array(indexyKostry),:] 
    return kostra 



def najdiKostruNahodnouLevnou(hranyKMG:np.ndarray): 
    """ Boruvka algo. je obdoba zaplavovani. 
    a inspirace pro muj stochasticky algoritmus. 
    Viz Mgr - Je videt, ze uzlu ma 41 a multihran 83, 
    coz neni tak moc. Kdyz kazdou multihranu zastoupi 
    nejlevnejsi hrana multihrany, vznikne prosty graf. 
    Ad nahodny generator: 
    83 hran je mene, nez puvodnich 320. Dale uvazuju jen nejlevnejsi 
    hrany z multihran. Proto najdiKostruNahodnouLevnou() da vysledky 
    lepsi, pokud na vstup dostane prave popsany zastupny graf multigrafu, 
    prosty komponentovy graf (PKG). 
    2 kroky: 
        1) najdiKostruNahodnouLevnou() najde kostru grafu PKG 
        2) na kazde hrane teto kostry se roztoci ruleta 
        a vybere se nahodna hrana z odpovidajiciho Mgr. 
    """ 
    # Na zaklade komponentoveho multigrafu (KMG) si pripravime 
    # prosty komponentovy graf (PKG), jeho hrany hranyPKG. 
    n = max(hranyKMG[:,0:2].ravel())+1 
    hranyPKG = [] 
    for k1 in range(n-1): 
        for k2 in range(k1,n): 
            shodne = np.logical_or(\
                np.logical_and(hranyKMG[:,0]==k1, hranyKMG[:,1]==k2), \
                np.logical_and(hranyKMG[:,1]==k1, hranyKMG[:,0]==k2)) 
            radek = [] 
            if any(shodne): 
                sub = hranyKMG[shodne,:] 
                kt = np.argmin(hranyKMG[shodne,2])   # nejlevnejsi 
                radek.extend([k1, k2]) 
                radek.extend(sub[kt,2:4].tolist()) 
                hranyPKG.append(radek) 
    hranyPKG = np.array(hranyPKG) 
    serazenyPKG = hranyPKG[np.argsort(hranyPKG[:,2]),:].copy() 
    # Vyber hran z PKG (- z nejlevnejsich zastupcu multihran KMG) 
    indexyHranKostry = [] 
    serazenyKMG = hranyKMG[np.argsort(hranyKMG[:,2]),:].copy() 
    pocetKomponent = len(np.unique(serazenyKMG[:,0:2])) 
    while (pocetKomponent > 1): 
        psti = 1/serazenyPKG[:,2] 
        psti = psti**2
        psti = psti / np.sum(psti) 
        cpsti = np.cumsum(psti) 
        vyber = np.where(cpsti > np.random.rand())[0][0] 
        znacka = serazenyPKG[vyber,0] 
        # konecne 
        indexHrany = serazenyPKG[vyber,3] 
        indexyHranKostry.append(indexHrany) 
        # oznaceni komponent stejnou znackou 
        serazenyPKG[serazenyPKG[:,0]==serazenyPKG[vyber,1],0] = znacka 
        serazenyPKG[serazenyPKG[:,1]==serazenyPKG[vyber,1],1] = znacka 
        # aktualizace grafu 
        nechat = (serazenyPKG[:,0]!=serazenyPKG[:,1]) 
        serazenyPKG = serazenyPKG[nechat,:] 
        if (len(serazenyPKG)!=0): 
            pocetKomponent = len(np.unique(serazenyPKG[:,0:2])) 
        else: 
            pocetKomponent = 1 
    # a mame kostru grafu PKG... 
    kostra = hranyKMG[indexyHranKostry,:].copy() 
    # ...kterou dale upravime nahodnym vyberem hrany
    # z odpovidajici multihrany multigrafu KMG. 
    kostra2 = kostra.copy() 
    for i in range(kostra.shape[0]):
        vyberCely = np.where(np.logical_or(
            np.logical_and(hranyKMG[:,0]==kostra[i,0],
                           hranyKMG[:,1]==kostra[i,1]), 
            np.logical_and(hranyKMG[:,0]==kostra[i,1],
                           hranyKMG[:,1]==kostra[i,0]) ))[0] 
        if len(vyberCely) > 0: 
            # Vyber z multihran 
            psti2 = 1 / hranyKMG[vyberCely,2] 
            psti2 = psti2**2
            psti2 = psti2 / np.sum(psti2) 
            cpsti2 = np.cumsum(psti2) 
            vyber2 = np.where(cpsti2 > np.random.rand())[0][0] 
            vyber = vyberCely[vyber2] 
            # konecne 
            kostra2[i,2] = hranyKMG[vyber,2]  # cenaHrany 
            kostra2[i,3] = hranyKMG[vyber,3]  # indexHrany 
    return kostra2 



def levneKostry(multigraf:tuple, pocetKoster:int): 
    """ all(kostra1[:,3] == kostra2[:,3]) 
    Test rovnosti dvou koster provadet nebudu, bo bych srovnaval O(n^2) koster.
    Radeji budu kostry generovat nahodne, pricemz prvni bude nejlevnejsi a ty 
    dalsi budou jen levne. Neni vyloucena duplikace, ale je malo pravdepodobna. 
    Nasledujici funkce generuje n levnych koster. """ 
    kostry = [] 
    # predevsim sestrojime jednu nejlevnejsi kostru: 
    tabuList = [] 
    smer = [0] * len(multigraf[0]) 
    graf = vyberGraf(multigraf, smer) 
    kostra = najdiKostru(graf, tabuList) 
    kostry.append(kostra) 
    n = len(multigraf[0]) 
    # nasleduji levne kostry sestrojene nahodne a bez kontroly duplikace: 
    for i in range(pocetKoster-1): 
        p = int(np.random.randint(0,n,1)) 
        q = int(np.random.randint(0,n,1)) 
        tabuList = [p] 
        smer = [0] * len(multigraf[0]) 
        smer[q] = 1 
        graf = vyberGraf(multigraf, smer) 
        kostra = najdiKostru(graf, tabuList) 
        kostry.append(kostra) 
    return kostry 



# jine funkce 

def obalMatici(matice:np.ndarray, vektor:list, cislo:int): 
    """ Na ctvercovou matici o rozmerech r x r priplacneme 
    do prava a dolu tentyz vektor delky r a pravy dolni 
    rozek vyplnime cislem cislo. """ 
    vektor = np.array(vektor).reshape(len(vektor),1) 
    matice = np.hstack((matice,vektor)) 
    vektor = vektor.ravel().tolist() 
    vektor.append(cislo) 
    vektor = np.array(vektor).reshape(1,len(vektor)) 
    matice = np.vstack((matice,vektor)) 
    return matice 

def argmatmax(matice): 
    """ Najde v matici prvni maximalni prvek a vrati dvojici (ir,is), 
    kde ir je index radku a is je index sloupce. """
    kdemax = np.argmax(matice) 
    idsloupce = kdemax % matice.shape[1] 
    idradku = kdemax // matice.shape[1] 
    return (idradku,idsloupce) 

""" Zjednoduseni zapisu hran pro neorientovane grafy, specialne CG. 
Pr.: v CG (kt. obs. 385 uzlu) je hrana z 15 do 311 totozna 
s hranou z 311 do 15. Obe tedz maji stejne cislo, ktere ziskame: 
min(311,15)*385 + max(311,15) = 15*385 + 311 = 6086. 
Zpatecni smer: min(6086 // 385, 6086 % 385) = 15,
max(6086 // 385, 6086 % 385) = 311. [15,311]. 
Oba smery maji stejne cislo. Z jednoho cisla ziskam oba smery. """ 
def kodzHranyCG(oddo): 
    N = casyCG.shape[0] 
    mensi = min(oddo[0],oddo[1]) 
    vetsi = max(oddo[0],oddo[1]) 
    kod = mensi * N + vetsi 
    return kod 
def hranaCGzkodu(kod): 
    N = casyCG.shape[0] 
    oddo = [kod // N, kod % N] 
    hrana = [min(oddo), max(oddo)] 
    return hrana 
def kodyzHranCG(oddoMatice): 
    N = casyCG.shape[0] 
    mensiMat = np.min(oddoMatice, axis=1) 
    vetsiMat = np.max(oddoMatice, axis=1) 
    kody = mensiMat * N + vetsiMat 
    return kody 
def hranyCGzkodu(kodyVektor): 
    N = casyCG.shape[0] 
    vek2 = np.reshape(kodyVektor // N, newshape=(len(kodyVektor),1)) 
    vek1 = np.reshape(kodyVektor % N, newshape=(len(kodyVektor),1)) 
    tmphrany = np.hstack((vek1, vek2)) 
    tmphrany = np.sort(tmphrany, axis=1) 
    return tmphrany 

# kodovani hran puvodniho grafu 
def kodzhrany(oddo): 
    N = uzly.shape[0] 
    mensi = min(oddo[0],oddo[1]) 
    vetsi = max(oddo[0],oddo[1]) 
    kod = mensi * N + vetsi 
    return kod 
def hranazkodu(kod): 
    N = uzly.shape[0] 
    oddo = [kod // N, kod % N] 
    hrana = [min(oddo), max(oddo)] 
    return hrana 
def kodyzhran(oddoMatice): 
    N = uzly.shape[0] 
    mensiMat = np.min(oddoMatice, axis=1) 
    vetsiMat = np.max(oddoMatice, axis=1) 
    kody = mensiMat * N + vetsiMat 
    return kody 
def hranyzkodu(kodyVektor): 
    N = uzly.shape[0] 
    vek2 = np.reshape(kodyVektor // N, newshape=(len(kodyVektor),1)) 
    vek1 = np.reshape(kodyVektor % N, newshape=(len(kodyVektor),1)) 
    tmphrany = np.hstack((vek1, vek2)) 
    tmphrany = np.sort(tmphrany, axis=1) 
    return tmphrany 

def miraVariability(maticeFeromonu): 
    """ 0 ~ stagnace ... az ... 1 ~ velka sance na zmenu """ 
    n = maticeFeromonu.shape[0] 
    xx = np.arange(n) 
    mi = np.min(maticeFeromonu) 
    ma = np.max(maticeFeromonu) 
    mf = maticeFeromonu.copy() 
    mf[xx,xx] = 2*abs(ma) # Ignorace Diagonaly 
    miid = np.min(mf) 
    mf[xx,xx] = -2*abs(mi) 
    maid = np.max(mf) 
    rid = (maid - miid) / 2 
    d1 = np.abs(mf - miid) 
    d2 = np.abs(mf - maid) 
    d3d = np.array([d1,d2]) 
    dd = np.min(d3d,axis=0) 
    if rid==0: 
        dd = np.ones([n,n]) 
    else: 
        dd = dd / rid 
    dd[xx,xx] = 0 
    return np.sum(dd,dtype=float) / ((n-1)*n) 



def dolniOdhad(hranyKMG, blokaceCG, legendaCG, 
               casyCG, startyCG, poctyTymuVeStanicich): 
    """ Dolni odhad hodnoty optimalniho reseni ulohy OPRBRN. 
    Vystupem je m-tice prirozenych cisel.  """ 
    m = poctyTymuVeStanicich.sum() 
    
    # Graf KMG mapuje na sebe jen doby oprav blokaci. 
    # Potrebujeme k dobam oprav blokaci pricist doby jizd pres blokace. 
    # V takto modifikovanem multigrafu KMGm hledame minimalni kostru. 
    hranyKMGm = hranyKMG.copy() 
    hranyKMGm[:,2] += casyCG[blokaceCG[:,0], blokaceCG[:,1]] 
    nejlevnejsiKostra = najdiKostru(hranyKMGm, []) 
    hodnota0 = nejlevnejsiKostra[:,2].sum() / m 
    dolniOdhad0 = [hodnota0] * m 
    
    komponent = max(legendaCG[:,2])+1     
    # # nejkratsi hrany v komponentach, ve kt to lze 
    # minima = [] 
    # for k in range(komponent): 
    #     indexy = legendaCG[legendaCG[:,2] == k, 1]
    #     tmpmat = casyCG[np.ix_(indexy,indexy)].copy() 
    #     # Na diagonale jsou nuly, ktere nam vadi. 
    #     tmpmat[np.arange(len(indexy)),np.arange(len(indexy))] = 2*np.max(tmpmat) 
    #     minimum = np.min(tmpmat) 
    #     # Pokud je komponenta listem v kostre grafu KMG, komponentou se neprojede 
    #     pocetSousednichKomponent = len(
    #         np.unique(np.hstack((hranyKMG[hranyKMG[:,0]==k,1], 
    #                              hranyKMG[hranyKMG[:,1]==k,0])))) 
    #     if (pocetSousednichKomponent <= 1): 
    #         minimum = 0 
    #     else: 
    #         # Setkaji-li se dve blokace ruznych dvojic komponent, minimum = 0. 
    #         for kruz in indexy: 
    #             sousedi = set() 
    #             sousedniKomponenty = set() 
    #             if any(blokaceCG[:,0]==kruz): 
    #                 sousedikruz = blokaceCG[blokaceCG[:,0]==kruz,1].tolist() 
    #                 sousedi = sousedi | set(sousedikruz) 
    #             if any(blokaceCG[:,1]==kruz): 
    #                 sousedikruz = blokaceCG[blokaceCG[:,1]==kruz,0].tolist() 
    #                 sousedi = sousedi | set(sousedikruz) 
    #             for soused in sousedi: 
    #                 sousedniKomponenty = sousedniKomponenty | set([legendaCG[soused,2]]) 
    #             if (len(sousedniKomponenty) >= 2): 
    #                 minimum = 0 
    #                 break 
    #     minima.append(minimum) 
    # hodnota1 = sum(minima) / m 
    # dolniOdhad1 = [hodnota1] * m 
    """ Ale tohle je taky spatne, protoze komponenta, ktera mela v kostre A 
    jen jednoho souseda, jich muze mit vice v kostre B. Bohuzel nevime, ktera 
    z koster je soucasti globalne optimalniho reseni. """ 
    dolniOdhad1 = [0] * m 
    
    # od stanic k nejblizsim blokacim 
    vnitrni = startyCG[legendaCG[startyCG,3] == 0]
    ucg = np.arange(casyCG.shape[0]) 
    ucg = np.setdiff1d(ucg, vnitrni)  # hranicni uzly 
    startyCGmod = startyCG[poctyTymuVeStanicich > 0] 
    poctyTymuVeStanicichMod = poctyTymuVeStanicich[poctyTymuVeStanicich > 0] 
    vzdalenostiZbytkuOdStanic = casyCG[np.ix_(startyCGmod,ucg)] 
    # kam = np.argmin(vzdalenostiZbytkuOdStanic,0) 
    # minima = [] 
    # for i in range(len(startyCGmod)): 
    #     minima.append(min(vzdalenostiZbytkuOdStanic[i,(kam == i)])) 
    minima = np.argmin(vzdalenostiZbytkuOdStanic,1) 
    dolniOdhad2 = [] 
    for i in range(len(poctyTymuVeStanicichMod)): 
        tmplist = [2 * int(minima[i])] * int(poctyTymuVeStanicichMod[i]) 
        dolniOdhad2.extend(tmplist)   # 2*int protoze se jede tam a zpet 
    
    # celkove 
    dolniOdhad = np.array(dolniOdhad0) + \
        np.array(dolniOdhad1) + np.array(dolniOdhad2) 
    return dolniOdhad 



def blokaceNaCGHrane(cgHrana): 
    """ Vypocet nejkratsich cest v puvodnim grafu mezi dvojicemi 
    zadanych uzlu v CG grafu prislusnemu puvodnimu grafu. 
    Funkce ma dva vystupy: blokaceNaCeste a cgCesta. 
    blokaceNaCeste... seznam indexu blokaciCG, ktere se vyskytuji 
    na nejkratsi ceste (v puvodnim grafu) mezi koncovymi uzly 
    zadane hrany cgHrana. 
    cgCesta... seznam uzlu CG, ktere se vyskytuji na nejkratsi 
    ceste v puvodnim grafu mezi koncovymi uzly zadane hrany cgHrana. """ 
    source = legendaCG[cgHrana[0],0] 
    target = legendaCG[cgHrana[1],0] 
    cesta = CESTY[source][target] 
    # Ktere blokace se na ni vyskytuji? Id do blokaceCG. 
    blokaceNaCeste = [] 
    # Kterymi CG uzly prochazi nejkratsi cesta puvodni site 
    # spojujici zadane uzly z CG ? 
    jevcg = np.in1d(np.array(cesta),legendaCG[:,0]) 
    cgCesta = [legendaCG[legendaCG[:,0]==cesta[0],1][0]] 
    for i in range(len(cesta)-1): 
        if (jevcg[i+1]): 
            druhy = (legendaCG[:,0]==cesta[i+1])
            cgCesta.append(legendaCG[druhy,1][0]) 
            if (jevcg[i]): 
                od = legendaCG[legendaCG[:,0] == cesta[i], 1][0] 
                do = legendaCG[legendaCG[:,0] == cesta[i+1], 1][0] 
                oddo = np.array([od,do]) 
                mask = np.logical_and(np.in1d(blokaceCG[:,0], oddo), 
                            np.in1d(blokaceCG[:,1], oddo)) 
                if any(mask): 
                    ukaz = np.where(mask)[0][0] 
                    blokaceNaCeste.append(ukaz) 
    return (blokaceNaCeste, cgCesta) 

blokaceCGkody = kodyzHranCG(blokaceCG[:,0:2]) 
""" Reseni se predpoklada ve tvaru reseniM nebo reseniZ. (~ vrcholy z CG) """
def poradiBlokacizReseni(reseni): 
    rts = reseni[0] 
    ros = reseni[1] 
    m = len(rts) 
    p_vsechny = [] 
    for i in range(m): 
        rt = rts[i] 
        ro = ros[i] 
        p_jedna = [] 
        for j in range(len(ro)): 
            if ro[j]==1: 
                kh = kodzHranyCG([rt[j], rt[j+1]]) 
                idbl = np.where(blokaceCGkody == kh)[0][0] 
                p_jedna.append(idbl) 
        p_vsechny.append(p_jedna) 
    return p_vsechny   # poradi blokaci kazde cety 

def resenizPoradiBlokaci(seznamPoradi, startyCG, poctyTymuVeStanicich): 
    seznamTras = [] 
    seznamSeznamuOprav = [] 
    pocetStanic = len(poctyTymuVeStanicich) 
    for i in range(pocetStanic): 
        for j in range(poctyTymuVeStanicich[i]): 
            seznamTras.append([startyCG[i]]) 
            seznamSeznamuOprav.append([]) 
    m = len(seznamTras) 
    for i in range(m): 
        p = seznamPoradi[i] 
        if len(p)<1: 
            continue 
        bls = blokaceCG[p,0:2] 
        trasa = seznamTras[i] 
        seznamOprav = seznamSeznamuOprav[i] 
        for j in range(bls.shape[0]): 
            pocUz = trasa[-1] 
            blhr = bls[j,:] 
            cesta1 = CESTY_CG[pocUz][blhr[0]] 
            cesta2 = CESTY_CG[pocUz][blhr[1]] 
            if len(cesta1)<=1 or len(cesta2)<=1: 
                if len(cesta1)<=1: 
                    trasa.append(blhr[1]) 
                else: 
                    trasa.append(blhr[0]) 
                seznamOprav.append(1) 
            else: 
                seznamOprav.append(0) 
                d1 = delkaTrasy(casyCG, cesta1) 
                d2 = delkaTrasy(casyCG, cesta2) 
                if d1 <= d2: 
                    trasa.append(blhr[0]) 
                    trasa.append(blhr[1]) 
                else: 
                    trasa.append(blhr[1]) 
                    trasa.append(blhr[0]) 
                seznamOprav.append(1) 
        if trasa[-1]!=trasa[0]:  # uzavreni okruhu 
            trasa.append(trasa[0]) 
            seznamOprav.append(0) 
    return (seznamTras, seznamSeznamuOprav) 




# kresleni obrazku

def ukazObraz(matice:np.array,d,h): 
    """ d=dolniMez, h=horniMez, napriklad k zobrazeni matice feromonu """
    tmpmat = np.round(255*(matice-d)/(h-d), decimals=0) 
    im = Image.fromarray(tmpmat) 
    im.show()
    del tmpmat 
    
# graf nejdelsich dob trvani praci cestaru v zavislosti na iteraci resice MMAS. 
def kresliMaxDoby(tabulkaCasy,nazev): 
    n = tabulkaCasy.shape[0] 
    x = np.arange(n) 
    y = tabulkaCasy[:,0] 
    plt.plot(x, y, 'b', marker="o", markersize=1, linewidth=0.5) 
    plt.savefig(nazev+'.svg') 

def kresliKomponenty(nazev): 
    """ Nakresli tlustymi barevnymi carami hrany puvodni site, 
    vsechny krome zablokovanych. Hrana dostane barvu podle 
    toho, v jake komponente lezi. 
    K pouziti spolu s kresliReseni(), ale do sveho plotu.""" 
    for k in range(komponent): 
        hhh = hranyKomponenty[hranyKomponenty[:,2]==k,0:2]
        for j in range(hhh.shape[0]): 
            barva = barvy2[k % len(barvy2)]
            if k==19:  # oprava barveni pro sit=1,k=21,t=3 
                barva = barvy2[-1] 
            plt.plot(xy[hhh[j,:],0], xy[hhh[j,:],1], barva, 
                 linewidth=0.8, alpha=1) 
    plt.savefig(nazev+'.svg') 

def kresliPuvodniGraf(): 
    for i in range(hrany.shape[0]): 
        plt.plot(xy[hrany[i,0:2],0], xy[hrany[i,0:2],1], 
                  'k', linewidth=0.5, alpha=0.33) 

def kresliReseni(reseni,nazev): 
    """ Vsechny trasy v jednom obrazku puvodni site. 
    K pouziti spolu s kresliKomponenty(), ale do sveho plotu.""" 
    kresliPuvodniGraf()
    m = len(reseni[0]) 
    paleta = barvy3 
    # Nad zablokovanymi hranami je cerne kolecko. 
    u1u2 = hrany[blokace.ravel(),0:2] 
    blxy = (xy[u1u2[:,0],:] + xy[u1u2[:,1],:])/2 
    plt.scatter(blxy[:,0],blxy[:,1],s=3,c='k',marker='o') 
    # Trasy 
    reseniG = adapterReseni_CG_G(reseni) 
    for i in range(m): 
        trasa = np.array(reseniG[0][i]) 
        ph = (len(trasa)-1) 
        for j in range(ph): 
            aph = 1 - j/(2*ph) 
            lwd = 0.8  #0.5 + 0.75*reseniG[1][i][j] 
            plt.plot(xy[trasa[j:(j+2)],0] + i*0.001, 
                      xy[trasa[j:(j+2)],1], 
                      paleta[i], alpha=aph, linewidth=lwd) 
        # Stanice 
        plt.plot(xy[trasa[0],0] + i*0.001, 
                  xy[trasa[0],1], 
                  paleta[i], marker="^", markersize=2) 
        # Odstranena blokace znazornena barevnym koleckem. 
        # Ma barvu podle toho, ktera ceta ji odstranila. 
        opravy = np.array(reseniG[1][i]) 
        leva = xy[(trasa[:-1])[opravy==1],:] 
        prava = xy[(trasa[1:])[opravy==1],:] 
        blxy = (leva + prava)/2 
        plt.scatter(blxy[:,0],blxy[:,1],s=4,c=paleta[i],marker='o') 
    # Ulozime (do slozky, ve ktere jsou tyto kody) 
    plt.savefig(nazev+'.svg') 


# Vstup / Vystup 

def ulozeni(tabulka, adresar, nazev): 
    outcesta = adresar + nazev + ".csv"
    outtabulka = pd.DataFrame(tabulka)
    outtabulka.to_csv(outcesta, header=False, index=False)

def nahrani(adresar, nazev): 
    inncesta = adresar + nazev + ".csv"
    tabulka = pd.read_csv(inncesta, header=None, delim_whitespace=False)
    return tabulka.to_numpy()

