# -*- coding: utf-8 -*-
"""
2023: 01: 21, 22, 23 

Reseni ulohy OPRBRN. 

Koncove reseni, zlepseni hlavniho reseni, Z. 
"""



"""
Po kazdem mravenci kolonii (m cet) nalezenem reseni by mel probehnout 
local search - nejaka modifikace 2 / 3 - optu. ( zlepseni() ) 

Zlepsovaci heuristiky. 
. Vymeny probihaji v ramci jedne kruznice (jedne trasy). 
. Blokace zafixuju, takze budou v puvodni i zlepsene trase. 
1) Zjistit opravene blokace (OB), jejich koncove uzly. 
2) Z nich a stanic sestavit posloupnosti CG uzlu bez CG cest je spojujicich. 
3) Nad hranami, ktere nejsou OB, provadet klasickou k-opt. 
4) Nove reseni napsat v podrobnem formatu, vc CG cest mezi uzly hrube trasy. 

Kroky 1-3 byly v ramci kazde trasy zvlast. V budoucnu lze zapojit 
i mezitrasovou vymenu uzlu a po ni nasledujici opet k-opt v ramci 
kazde trasy zvlast (jako ve VRP). 
"""



import math as mm 
import pomocne as pm 
import numpy as np 
#import time



# adapter reseni M pro k-opt do formatu reseni Z 
def adapterReseniMZ(reseni): 
    trasyJemne = reseni[0] 
    opravyJemne = reseni[1] 
    trasyHrube = [] 
    opravyHrube = [] 
    def f1(list1, list2): 
        tmp = list2.copy() 
        tmp.append(0) 
        uka1 = np.array(tmp) 
        tmp = [0] 
        tmp.extend(list2.copy()) 
        uka2 = np.array(tmp) 
        tmp = [0]*len(list1) 
        tmp[0] = 1 
        tmp[-1] = 1 
        uka3 = np.array(tmp) 
        uka = np.logical_or(uka1==1, uka2==1) 
        uka = np.logical_or(uka, uka3==1) 
        tmp = np.array(list1) 
        tmp = tmp[uka].copy() 
        return tmp.tolist() 
    def f2(list2): 
        if (len(list2)<2): 
            tmp = list2.copy() 
            return np.array(tmp) 
        else: 
            novy = [list2[0]] 
            for i in range(1,len(list2)):
                if (list2[i]==1): 
                    novy.append(1) 
                else:  # list2[i]==0 
                    if (novy[-1]==1): 
                        novy.append(0) 
                    else:  # (novy[-1]==0)
                        0  # nic nedelame 
            return novy 
    m = len(trasyJemne) 
    for i in range(m):   # pro kazdeho mravence 
        th = f1(trasyJemne[i], opravyJemne[i]) 
        oh = f2(opravyJemne[i]) 
        trasyHrube.append(th) 
        opravyHrube.append(oh) 
    return (trasyHrube, opravyHrube) 
# Preved reseni_009 = 
# ([10,7,3,11, 18,5,51,12, 9,10], [0,0,0,0, 1,0,0, 0,0], [10, 18,12, 10]) 
# na reseni r9 = 
# ([10,18,5,10], [0,1,0]) 



""" 
Zde upravim 2-opt a 3-opt z TSP, aby probihal jen nad hranami, 
ktere jsou mimo tabu list hran. Tabu list hran bude obsahovat 
ty hrany, ktere si chceme uchovat. 
""" 
def opt2(trasa:np.ndarray, opravy:np.ndarray, 
         ceny:np.ndarray, limit:int=mm.inf): 
    """
    Vstupy: 
        trasa... vektor, indexy CG uzlu trasy jednoho mravence
            Trasa musi prijit v takovem tvaru, ze zadne dve blokace 
            nejsou oddeleny dvemi nebo vice neblokovanymi CG hranami. 
        opravy... vektor o 1 kratsi, nez trasa. Hodnoty 1 = blokace opravena, 
            0 = prujezdna hrana nebo neopravena blokace. 
        ceny... matice cen hran v CG 
        limit... implicitne nekonecno, v tom pripade probehne 2-opt az do konce, 
            coz muze trvat dlouho, ale lepsi zlepseni reseni s 2-opt nedostaneme. 
            Pokud konecne cislo M, tak zameni jen M dvojic hran za nove dvojice, 
            behem M iteraci. Na opravene blokace tato funkce nesaha. 
    Prace: 
        V pripade limit=math.inf dela vymenu hran tak dlouho, dokud se cena 
        zmeneho reseni zmensuje. V pripade M = limit < math.inf vymeni 
        jen M dvojic hran, aby vypocet bezel prijatelne dlouho. Cim je limit 
        mensi, tim horsi je kvalita nalezeneho reseni. 
    Vystupy: 
        trasa... vylepsena vstupni trasa 
    """
    trhr = np.vstack((trasa[:-1], trasa[1:])) 
    trhr = trhr.transpose() 
    trhr = trhr[opravy==1,:] 
    kodyOpravenychHran = pm.kodyzHranCG(trhr) 
    n = len(trasa) 
    zkraceno = True 
    M = 0 
    while zkraceno: 
        if (M >= limit): 
            break 
        zkraceno = False 
        nejvetsiZkraceni = -mm.inf 
        kde = None 
        for k in np.arange(n-2): 
            i = trasa[k] 
            i1 = trasa[k+1] 
            konec = n-(k==0) 
            if (pm.kodzHranyCG([i,i1]) in kodyOpravenychHran): 
                continue   # preskocime opravene hrany 
            for l in np.arange(k+2, konec, 1): 
                j = trasa[l] 
                if (l < n-1): 
                    j1 = trasa[l+1] 
                else: 
                    j1 = trasa[0] 
                if (pm.kodzHranyCG([j,j1]) in kodyOpravenychHran): 
                    continue   # preskocime opravene hrany 
                zkraceni = ceny[i,i1] + ceny[j,j1] - ceny[i,j] - ceny[i1,j1] 
                if (zkraceni > nejvetsiZkraceni): 
                    nejvetsiZkraceni = zkraceni 
                    kde = [k,l] 
        M = M + 1 
        if (nejvetsiZkraceni > 0): 
            k = kde[0] 
            l = kde[1] 
            trasa = np.concatenate((
                trasa[:(k+1)], trasa[l:k:-1], trasa[(l+1):])) 
            zkraceno = True
        # Zaverecna identifikace blokaci 
        opraveneBlokace = [] 
        dosavadniBlokace = set() 
        for i in range(1,len(trasa)): 
            kodh = pm.kodzHranyCG([trasa[i-1], trasa[i]]) 
            if (kodh in kodyOpravenychHran and not kodh in dosavadniBlokace): 
                opraveneBlokace.append(1) 
            else: 
                opraveneBlokace.append(0) 
            dosavadniBlokace |= {kodh} 
    return (trasa.tolist(), opraveneBlokace) 

# np.arange(3,8,1)  # 3 4 5 6 7 

not 1 in set([2,3,4])
set([2,3]) | {4} 

def opt3(trasa:np.ndarray, opravy:np.ndarray, 
         ceny:np.ndarray, limit:int=mm.inf):
    """
    Vstupy: 
        trasa... vektor, indexy CG uzlu trasy jednoho mravence
            Trasa musi prijit v takovem tvaru, ze zadne dve blokace 
            nejsou oddeleny dvemi nebo vice neblokovanymi CG hranami. 
        opravy... vektor o 1 kratsi, nez trasa. Hodnoty 1 = blokace opravena, 
            0 = prujezdna hrana nebo neopravena blokace. 
        ceny... matice cen hran v CG 
        limit... implicitne nekonecno, v tom pripade probehne 3-opt az do konce, 
            coz muze trvat dlouho, ale lepsi zlepseni reseni s 3-opt nedostaneme. 
            Pokud je cislo M konecne, tak zameni jen M dvojic hran za nove dvojice, 
            behem M iteraci. 
    Prace: 
        V pripade limit=math.inf dela vymenu hran tak dlouho, dokud se cena 
        zmeneho reseni zmensuje. V pripade M = limit < math.inf vymeni 
        jen M dvojic hran, aby vypocet bezel prijatelne dlouho. Cim je limit 
        mensi, tim horsi je kvalita nalezeneho reseni. Na opravene blokace 
        tato funkce nesaha. 
    Vystupy: 
        trasa... vylepsena vstupni trasa 
    """
    trasa = np.array(trasa, dtype=int) 
    trhr = np.vstack((trasa[:-1], trasa[1:])) 
    trhr = trhr.transpose() 
    trhr = trhr[opravy==1,:] 
    kodyOpravenychHran = pm.kodyzHranCG(trhr) 
    n = len(trasa) 
    zkraceno = True 
    M = 0 
    def opt3permutace(a,b,c,d,e,f): 
        perlist = [ [a,c,b,d,e,f], [a,e,d,c,b,f], [a,b,c,e,d,f], 
                    [a,c,b,e,d,f], [a,d,e,c,b,f], [a,e,d,b,c,f], 
                    [a,d,e,b,c,f] ] 
        return perlist
    def permutuj(co,jak): 
        # co.. list, jak.. tuple(list,list), vse stejne dlouhe 
        #            jak.. tuple(pred,pote) 
        perm = np.array([None] * len(co)) 
        pred = jak[0] 
        pote = jak[1] 
        for i in range(len(co)): 
            vhodnaMista = np.logical_and( pred[i] == np.array(pote), perm==None) 
            kam = np.where(vhodnaMista)[0][0] 
            perm[kam] = co[i] 
        return perm 
    def prehodHrany(trasa:np.ndarray, permutovaneIndexy:list): 
        po = permutovaneIndexy 
        levy = trasa[0:(po[0]+1)] 
        if (po[5]==0): 
            pravy = np.array([]) 
        else: 
            pravy = trasa[po[5]:len(trasa)] 
        stredL = np.array([]) 
        stredP = np.array([]) 
        if (po[1] < po[2]): 
            stredL = trasa[po[1]:(po[2]+1)] 
        else: 
            stredL = trasa[po[1]:(po[2]-1):-1] 
        if (po[3] < po[4]): 
            stredP = trasa[po[3]:(po[4]+1)] 
        else: 
            stredP = trasa[po[3]:(po[4]-1):-1] 
        trasa = np.concatenate((levy, stredL, stredP, pravy)) 
        return trasa 
    while zkraceno: 
        if (M >= limit): 
            break 
        zkraceno = False 
        nejvetsiZkraceni = -mm.inf 
        kde = None 
        jake = None 
        for i in np.arange(n-4): 
            p = int(trasa[i]) 
            p1 = int(trasa[i+1]) 
            if (pm.kodzHranyCG([p,p1]) in kodyOpravenychHran): 
                continue   # preskocime opravene hrany 
            for j in np.arange(i+2, n-2, 1): 
                q = int(trasa[j]) 
                q1 = int(trasa[j+1]) 
                konec = n-(i==0) 
                if (pm.kodzHranyCG([q,q1]) in kodyOpravenychHran): 
                    continue   # preskocime opravene hrany 
                for k in np.arange(j+2, konec, 1): 
                    r = int(trasa[k]) 
                    r1 = int(trasa[(k+1) % n]) 
                    if (pm.kodzHranyCG([r,r1]) in kodyOpravenychHran): 
                        continue   # preskocime opravene hrany 
                    dosud = ceny[p,p1] + ceny[q,q1] + ceny[r,r1] 
                    for L in opt3permutace(p,p1,q,q1,r,r1): 
                        altr = ceny[L[0],L[1]]+ceny[L[2],L[3]]+ceny[L[4],L[5]] 
                        zkraceni = dosud - altr 
                        if (zkraceni > nejvetsiZkraceni): 
                            nejvetsiZkraceni = zkraceni 
                            kde = [i,j,k] 
                            jake = L 
        M = M + 1 
        if (nejvetsiZkraceni > 0): 
            i = kde[0] 
            j = kde[1] 
            k = kde[2] 
            permutovaneIndexy = permutuj( [i, i+1, j, j+1, k, (k+1) % n], 
                     ([trasa[i], trasa[i+1], trasa[j], 
                       trasa[j+1], trasa[k], trasa[(k+1) % n]], jake)) 
            trasa = prehodHrany(trasa, permutovaneIndexy) 
            zkraceno = True
    trasa = np.array(trasa, dtype=int) 
    # Zaverecna identifikace blokaci 
    opraveneBlokace = [] 
    dosavadniBlokace = set() 
    for i in range(1,len(trasa)): 
        kodh = pm.kodzHranyCG([trasa[i-1], trasa[i]]) 
        if (kodh in kodyOpravenychHran and not kodh in dosavadniBlokace): 
            opraveneBlokace.append(1) 
        else: 
            opraveneBlokace.append(0) 
        dosavadniBlokace |= {kodh} 
    return (trasa.tolist(), opraveneBlokace) 



def zlepsi(reseni:tuple, algoritmus:str, limit:int=mm.inf): 
    """
    Z modulu reseniZ prednostne volejme tuhle funkci, protoze ona pripravi 
    vstupni reseni do podoby, se kterou umi pracovat opt2 nebo opt3. 
    Vstupy: 
        reseni... format M, trojice (trasy, opravy, mravenciVolby) 
            trasy... m-tice (sezanam) tras, kazdy mravenec ma jednu, 
                trasa je uzavrena cesta - konci tam, kde zacina 
            opravy, mravanciVolby... jsou take sezanmy delky m. 
        algoritmus... string, na vyber je 'opt2' nebo 'opt3' 
        limit... implicitne nekonecno, v tom pripade probehne k-opt az do konce, 
            coz muze trvat dlouho, ale lepsi zlepseni reseni s k-opt nedostaneme. 
            Pokud je cislo M konecne, tak zameni jen M dvojic hran za nove dvojice, 
            behem M iteraci. 
    Vystupy: 
        reseni2... vylepsene vstupni reseni ve formatu M
    """   
    ceny = pm.casyCG 
    reseni2 = adapterReseniMZ(reseni) 
    m = len(reseni[0]) 
    trasy3 = [] 
    opravy3 = [] 
    for i in range(m): 
        trasa = np.array(reseni2[0][i]) 
        opravy = np.array(reseni2[1][i]) 
        if len(trasa)<=2: 
            trasy3.append(trasa) 
            opravy3.append(opravy) 
        else:   # da se neco delat 
            # k-opt chce trasy nekoncici ve startu 
            trasa = trasa[:-1] 
            opravy = opravy[:-1] 
            # Jadro funkce zlepseni 
            if algoritmus=='opt2': 
                if len(trasa)>=4: 
                    vylepsene = opt2(trasa, opravy, ceny, limit) 
                else: 
                    vylepsene = (trasa.tolist(), opravy.tolist()) 
            else: #algoritmus=='opt3': 
                if len(trasa)>=6: 
                    vylepsene = opt3(trasa, opravy, ceny, limit) 
                else: 
                    vylepsene = (trasa.tolist(), opravy.tolist()) 
            # uzavreme trasu do okruhu 
            if vylepsene[0][-1] != vylepsene[0][0]: 
                vylepsene[0].append(vylepsene[0][0]) 
                vylepsene[1].append(0) 
            trasy3.append(vylepsene[0]) 
            opravy3.append(vylepsene[1]) 
    return (trasy3, opravy3) 


