# -*- coding: utf-8 -*-
"""
2022:09: 18, 
2023:02: 24 
2023:03: 19 
Data k uloze se nachazi napriklad v souboru: 
C:\\Prilohy\\Data\\ulohy" 
"""



import numpy as np 
import pandas as pd 



def uloha(sit:str, situace:str): 
    zp = ".txt"
    promenne = {}  # pro vystup 
    # promenne 
    zdroj_sit = sit + "\\"         # vstupni sit 
    zdroj_situace = situace + "\\" # situace 
    nazevUlohy = zdroj_sit + zdroj_situace
    promenne["nazevUlohy"] = nazevUlohy 
    
    def zdroj2(zdroj_typ): 
        return zdroj_sit + zdroj_typ + zp 
    def zdroj3(zdroj_typ): 
        return zdroj_sit + zdroj_situace + zdroj_typ + zp 
    
    # Puvodni sit 
    # Pozice uzluu v rovine 
    xy = pd.read_csv(zdroj2("xy"), header="infer", sep=" ")
    xy = xy.to_numpy() 
    promenne["xy"] = xy
    # Uzly puvodni site s poctem obyvatel 
    uzly = pd.read_csv(zdroj2("uzly"), header="infer", sep=" ")
    uzly = uzly.to_numpy() 
    promenne["uzly"] = uzly
    # Hrany puvodni site s trvanim presunu po hrane 
    hrany = pd.read_csv(zdroj2("hrany"), header="infer", sep=" ")
    hrany = hrany.to_numpy() 
    promenne["hrany"] = hrany
    
    # Situace na puvodni siti 
    # blokace 
    blokace = pd.read_csv(zdroj3("blokace"), header=None)
    blokace = blokace.to_numpy()
    promenne["blokace"] = blokace
    # doby oprav blokaci 
    doby_oprav = pd.read_csv(zdroj3("doby_oprav"), header=None)
    doby_oprav = doby_oprav.to_numpy() 
    promenne["doby_oprav"] = doby_oprav
    # umisteni stanic silnicaru 
    starty = [] 
    with open(zdroj3("starty"), "r") as file: #Otevre soubor a automaticky ho po ukonceni nebo chybe zavre
        for cradku, radek in enumerate(file):
            starty.append(int(radek)) 
    promenne["starty"] = starty
    # do ktere komponenty patri ktery uzel 
    uzlyKomp = pd.read_csv(zdroj3("uKompId"), header=None)
    uzlyKomp = uzlyKomp.to_numpy() 
    promenne["uzlyKomp"] = uzlyKomp
    # ["id"] hranicni uzly komponent puvodni site sjednoceny se stanicemi (starty) 
    uzlyCG = pd.read_csv(zdroj3("uzlyCG"), header=0)
    uzlyCG = uzlyCG.to_numpy() 
    # uzlyCG obsahuji sjednoceni krajnich uzlu se starty 
    # Proto zavedeme 1. indikator, ktery uzel je krajni 
    # a 2. indikator, ktery uzel je startovni 
    kroddo = hrany[blokace.ravel(), 0:2] 
    krajniUzly = np.union1d(kroddo[:,0], kroddo[:,1]) 
    # legendaCG popisuje radky a sloupce maticeCG. 
    # [id(G), id(CG), vKomponenteCislo, jeHranicni, jeStanice] 
    # Je-li uzel hranicni, tak jeHranicni = 1, jinak jeHranicni = 0. 
    # Je-li v uzlu stanice, tak jeStanice = 1, jinak jeStanice = 0. 
    legendaCG = np.zeros(shape=(len(uzlyCG),5),dtype=int) 
    legendaCG[:,0] = uzlyCG.ravel()  # id uzlu v puvodnim grafu (G) 
    legendaCG[:,1] = range(len(uzlyCG))  # id uzlu v uplnem grafu (CG) 
    legendaCG[:,2] = uzlyKomp[legendaCG[:,0]].ravel() 
    legendaCG[:,3] = np.in1d(legendaCG[:,0], krajniUzly) * 1 
    legendaCG[:,4] = np.in1d(legendaCG[:,0], starty) * 1 
    promenne["legendaCG"] = legendaCG 
    # blokace indexovane v uplnem grafu CG, [idCGod, idCGdo, casOpravy] 
    # jde o neorientovany graf, proto blokaceCG uchovava jen jeden smer 
    blokaceCG = np.zeros(shape=(len(blokace),3),dtype=int) 
    tpmp = hrany[blokace.ravel(),0:2]
    for i in range(len(blokace)): 
        idcgod = np.where(legendaCG[:,0] == tpmp[i,0])[0][0] 
        idcgdo = np.where(legendaCG[:,0] == tpmp[i,1])[0][0] 
        casopravy = doby_oprav[i] 
        blokaceCG[i,:] = [idcgod, idcgdo, casopravy] 
    promenne["blokaceCG"] = blokaceCG 
    # casy pruchodu hranou v CG 
    casyCG = pd.read_csv(zdroj3("casyCG"), sep=",", header=None, engine='python')   # kvuli sep=", " uzit i engine='python'
    casyCG = casyCG.to_numpy()
    promenne["casyCG"] = casyCG
    # starty indexovane v uplnem grafu CG 
    startyCG = [] 
    for idu in starty: 
        startyCG.append(np.where(legendaCG[:,0] == idu)[0][0]) 
    startyCG = np.array(startyCG) 
    promenne["startyCG"] = startyCG 
    
    # # ["uzel1" "uzel2" "sekund"] hrany v uplne siti CG jsou tvoreny dvojicemi 
    # # hranicnich uzlu komponent puvodni site 
    # hranyCG = pd.read_csv(zdroj3("hranyCG"), delim_whitespace=True, header=0)
    # hranyCG = hranyCG.to_numpy()
    # promenne["hranyCG"] = hranyCG
    # # seznam seznamu uzlu tvoricich nejrychlejsi cestu mezi kazdou dvojici 
    # # hranicnich uzlu komponent puvodniho grafu 
    # nejrychlejsiCesty = [] 
    # with open(zdroj3("nejrychlejsiCesty"), "r") as file: #Otevre soubor a automaticky ho po ukonceni nebo chybe zavre
    #     for cradku, radek in enumerate(file):
    #         tmplis = radek.split(sep=" ")   # ends with '\n' 
    #         tmplis = (np.array(tmplis)[np.array(tmplis) != '\n']).tolist() 
    #         lisint = [int(s) for s in tmplis]
    #         nejrychlejsiCesty.append(lisint) 
    # promenne["nejrychlejsiCesty"] = nejrychlejsiCesty
    
    # uzly komponentoveho multigrafu 
    # uzlyKMG: [komponentaId, pocetObyvatelVKomponente] 
    maxKompId = max(uzlyKomp)[0] 
    uzlyKMG = [] 
    for i in range(maxKompId+1): 
        uzlyKMG.append([i, sum(uzly[np.array(uzlyKomp[:,0]==i),1])]) 
    uzlyKMG = np.array(uzlyKMG) 
    promenne["uzlyKMG"] = uzlyKMG 
    # hrany komponentoveho multigrafu jsou blokace puvodniho drafu, ktere zpusobily rozpad 
    # hranyKMG: [odKomp1, doKomp2, dobaOpravy, dobaJizdy, odUzel1, doUzel2] 
    # odKomp1, doKomp2... cisla (indexy) komponent 
    # odUzel1, doUzel2... cisla (indexy) uzluu v puvodnim grafu 
    # Prvni tri sloupce hranyKMG jsou hlavni. Ostatni jsou upresnujici. 
    hranyKMG = [] 
    for idbl in range(len(blokace)): 
        j = blokace[idbl,0] 
        odUzel1, doUzel2, dobaJizdy = hrany[j,:] 
        dobaOpravy = doby_oprav[idbl,0] 
        odKomp1 = uzlyKomp[odUzel1,0] 
        doKomp2 = uzlyKomp[doUzel2,0] 
        hranyKMG.append([odKomp1, doKomp2, dobaOpravy, idbl]) 
    # idbl je index blokace v blokace i v blokaceCG od 0 do len(blokace) 
    hranyKMG = np.array(hranyKMG) 
    promenne["hranyKMG"] = hranyKMG 
    return promenne 





# # Priklad nahravani ulohy: 
# sit = "C:\\Prilohy\\Ulohy\\sit002" 
# situace = "k41d05" 
# promenne = uloha(sit, situace) 
# xy = promenne["xy"] 
# uzly = promenne["uzly"] 
# hrany = promenne["hrany"] 
# starty = promenne["starty"] 
# blokace = promenne["blokace"] 
# doby_oprav = promenne["doby_oprav"] 
# legendaCG = promenne["legendaCG"] 
# casyCG = promenne["casyCG"] 
# blokaceCG = promenne["blokaceCG"] 
# startyCG = promenne["startyCG"] 
# uzlyKomp = promenne["uzlyKomp"] 
# nazevUlohy = promenne["nazevUlohy"] 
# uzlyKMG = promenne["uzlyKMG"] 
# hranyKMG = promenne["hranyKMG"] 
# del sit, komponent, dep 
# del promenne 

