# 2022.02.: 15, 

# dekoder siti dekoder.R, nasleduje po dekoder_xo.R 



library(stringr)



# pracovni slozka 
setwd("C:/Users/acer/workspace_R/OPRBRN/003") 

# adresar s daty obecne 
dataDir = "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data"

# adresar s daty k dekodovani 
dataIn = paste(dataDir,"zranitelnost",sep="/")

# datove soubory 
dataFiles = list.files(dataIn, pattern=NULL, all.files=FALSE, full.names=FALSE) 

# Z txt souboru nacte radek po radku do vektoru typu String. 
loadFile = function(filepath) {
  lines = c() 
  con = file(filepath, "r")
  while ( TRUE ) {
    line = readLines(con, n = 1)
    if ( length(line) == 0 ) {
      break
    }
    lines = c(lines, line) #print(line)
  }
  close(con)
  return(lines)
}

# Z radku ziska uzly a hrany v maticovem formatu 
patt_uo = "\\d+[A-Z]\\d+;\\d+[ ]+" 
patt_sohdc = "\\w+;\\d+;[ a-zA-Z0-9]+;\\d+;\\d+" 
processLine = function(line){
  u = 1
  h = 1
  uzly = data.frame() 
  hrany = data.frame() 
  stredStr = str_extract_all(line, patt_uo)[[1]] 
  okoliStr = str_extract_all(line, patt_sohdc)[[1]] 
  uzel_id = str_split(stredStr,";")[[1]]
  obyvatel = as.numeric(uzel_id[2])
  uzel_id = uzel_id[1]
  uzly[u,1] = uzel_id
  uzly[u,2] = obyvatel
  u = u+1
  for(i in 1:length(okoliStr)){
    sousedStr = str_extract(okoliStr[i], "\\d+[A-Z]\\d+;\\d+")
    uzel2_id = str_split(sousedStr,";")[[1]]
    obyvatel2 = as.numeric(uzel2_id[2])
    uzel2_id = uzel2_id[1]
    uzly[u,1] = uzel2_id
    uzly[u,2] = obyvatel2
    u = u+1
    hrana_dc = str_extract(okoliStr[i], "\\d+;\\d+$") 
    hranaDelka = str_split(hrana_dc,";")[[1]]
    hranaCas = as.numeric(hranaDelka[2])
    hranaDelka = as.numeric(hranaDelka[1])
    hrany[h,1] = uzel_id
    hrany[h,2] = uzel2_id
    hrany[h,3] = hranaDelka
    hrany[h,4] = hranaCas
    h = h+1
  }
  out = list(uzly = uzly, hrany = hrany)
  return(out)
}

# Cely soubor prevede na matici uzlu a matici hran 
# uzly i hrany se tam opakuji 
processFile = function(radky){
  uzly = data.frame() 
  hrany = data.frame() 
  for(i2 in 1:length(radky)){
    line = radky[i2] 
    res = processLine(line)
    uzly = rbind(uzly, res$uzly) 
    hrany = rbind(hrany, res$hrany) 
  }
  names(uzly) = c("id", "obyvatel")
  names(hrany) = c("uzel1", "uzel2", "metru", "sekund")
  out = list(uzly = uzly, hrany = hrany)
  return(out)
}

deduplikujUzly = function(uzly){
  fctid = as.factor(uzly$id)
  lvls = levels(fctid)
  unikaty = data.frame()
  for(i in 1:length(lvls)){
    match = which(lvls[i] == uzly$id)
    ggg = as.integer(mean(uzly$obyvatel[match],na.rm=T)) 
    unikaty[i,1] = lvls[i] 
    unikaty[i,2] = ggg 
  }
  names(unikaty) = c("id", "obyvatel")
  return(unikaty)
}

deduplikujHrany = function(hrany){
  unikaty = data.frame()
  k = 1  # index radku v unikaty 
  for(i in 1:dim(hrany)[1]){
    if(i==1){  # protoze v unikaty dosud nic neni 
      unikaty[k,1] = hrany$uzel1[1]
      unikaty[k,2] = hrany$uzel2[1] 
      unikaty[k,3] = hrany$metru[1] 
      unikaty[k,4] = hrany$sekund[1] 
      k = k+1 
    } else {
      p1 = (hrany$uzel1[i] == unikaty[,1]) & (hrany$uzel2[i] == unikaty[,2]) 
      p2 = (hrany$uzel1[i] == unikaty[,2]) & (hrany$uzel2[i] == unikaty[,1]) 
      if(any(p1 | p2)){
        next
      }else{
        unikaty[k,1] = hrany$uzel1[i]
        unikaty[k,2] = hrany$uzel2[i] 
        unikaty[k,3] = hrany$metru[i] 
        unikaty[k,4] = hrany$sekund[i] 
        k = k+1 
      }
    } 
  }
  names(unikaty) = c("uzel1", "uzel2", "metru", "sekund")
  return(unikaty)
}


dataOut = paste(dataDir,"matice",sep="/") 
hranyDest = paste(dataOut,"hrany",sep="/") 
uzlyDest = paste(dataOut,"uzly",sep="/") 
save = function(data, typuh, nazev){
  if (typuh=="uzly"){
    kmen = uzlyDest 
  } else if (typuh=="hrany"){
    kmen = hranyDest 
  } else {} 
  kam = paste(kmen,nazev,sep = "/")
  write.table(data, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = TRUE) 
}


# Dekodovani vsech datovych souboru 
for(i in 1:length(dataFiles)){
  soubor = paste(dataIn,dataFiles[i],sep = "/")
  radky = loadFile(soubor)
  res = processFile(radky)
  uzly = res$uzly
  hrany = res$hrany
  uzly_uniq = deduplikujUzly(uzly)
  hrany_uniq = deduplikujHrany(hrany)
  save(uzly_uniq,"uzly",dataFiles[i])
  save(hrany_uniq,"hrany",dataFiles[i])
}


# # Tohle uz je hotove a netreba to spoustet znova. 
# source("C:/Users/acer/workspace_R/OPRBRN/003/dekoder.R") 


