# 2022.02.: 20, 

# Destruktor 
# Vstupni sit necht je souvisla. 
# Uzavrenim vybranych hran zpusobi rozpad site na komponenty souvislosti. 



library(igraph) 
library(dequer)



# pracovni slozka 
setwd("C:/Users/acer/workspace_R/OPRBRN/003") 

# adresare, data obecne a data uzlu a hran 
dataDir = "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data"
dataIn = paste(dataDir,"matice",sep="/") 
hranyDir = paste(dataIn,"02hrany",sep="/") 
uzlyDir = paste(dataIn,"02uzly",sep="/") 

dataFiles = list.files(uzlyDir, pattern=NULL, all.files=FALSE, full.names=FALSE) 
# Vsechny site z nasledujiciho dvojadresare jsou souvisle: 
# "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data/matice/02hrany"
# "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data/matice/02uzly"



# Nahrajeme data pro sit (uzly, hrany): 
nazevSite = dataFiles[1]                  ### << IN 
uzly <- read.csv(paste(uzlyDir,nazevSite,sep="/"), sep="") 
hrany <- read.csv(paste(hranyDir,nazevSite,sep="/"), sep="") 
nu = dim(uzly)[1] 
nh = dim(hrany)[1] 

# Vytvorime sit a na ni zavisle funkce, z nichz prvni vraci 
# indexy sousednich uzlu v uzly a druha indexy okolnich hran v hrany 
G = graph_from_data_frame(d=hrany, vertices=uzly, directed=F) 
getSousedi = function(id_uzlu){
  return( as.vector(neighbors(G, id_uzlu, mode="all")) )
}
getOkoli = function(id_uzlu){
  return( as.vector(incident(G, id_uzlu, mode="all")) )
}



# Nulu hrana ziska pokud je incidentni se dvema uzly ruznych komponent. 
novaBarvaHrany = function(barvaUzlu1, barvaUzlu2){
  if((barvaUzlu1<0) && (barvaUzlu2<0)){return(-1)}
  if((barvaUzlu1<0) && (barvaUzlu2>0)){return(barvaUzlu2)}
  if((barvaUzlu1>0) && (barvaUzlu2<0)){return(barvaUzlu1)}
  if((barvaUzlu1>0) && (barvaUzlu2>0)){
    if(barvaUzlu1!=barvaUzlu2){return(0)}
    else{return(barvaUzlu1)}
  }
}

# Generator blokacii dane site. 
# Paralelni BFS z nekolika center soucasne. 
# Vyzaduje souvislou vstupni sit. 
# matice uzlu, matice hran; centra ~ vektor indexu centralnich uzluu 
# Z centralniho uzlu se po uzlech site rozpinaji nove komponenty, 
# dokud se nepotkaji. Funkce vraci indexy hran oddelujicich komponenty. 
dejBlokace = function(uzly, hrany, centra){
  
  # Inicializace 
  labU = rep(-1, nu)   # -1 ~ neoznaceny uzel 
  labH = rep(-1, nh)   # -1 ~ neoznacena hrana 
  frontySousedu = list()
  for(k in 1:nc){
    labU[centra[k]] = centra[k]
    frontySousedu[[k]] = queue()
    pushback(frontySousedu[[k]], centra[k])
  }
  
  # Rozpinani center po uzlech site (barveni uzlu) 
  podminka = TRUE 
  while(podminka){
    for(k in 1:nc){
      ff = frontySousedu[[k]]
      uid = pop(ff)
      suids = getSousedi(uid)
      if(length(suids)>0){
        novi = suids[(labU[suids]==-1)]
        if(length(novi)>0){
          labU[novi] = centra[k] ##
          for(i in 1:length(novi)){
            pushback(ff,novi[i]) 
          }
        }
      }
    }
    podminka = FALSE 
    for(k in 1:nc){ podminka = podminka || (length(frontySousedu[[k]])>0) } 
  }
  
  # Barveni hran 
  for(i in 1:nh){
    labH[i] = novaBarvaHrany(labU[hrany[i,1]], labU[hrany[i,2]]) 
  }
  blokace = which(labH==0)
  
  return(blokace)
} # end dejBlokace() 



nc = 20                                  ### << IN 
centra = sample(nu, nc)                  ### << IN 

# Vystupy ke zpracovani dalsimi soubory. ### >> OUT  
blokace = dejBlokace(uzly, hrany, centra)



# # Tady muzeme ulozit vsechna data z workspace:
# save.image("C:/Users/acer/workspace_R/OPRBRN/003/wspchpt/KV_nepo_20komp_01.RData")



# # Testy 
# nc = 6   # Na kolik komponent sit rozdelime? 
# res = c()
# for(i in 1:10){
#   centra = sample(nu, nc) 
#   blokace = dejBlokace(uzly, hrany, centra)
#   #length(blokace) / nh
#   hrany_2 = hrany[-blokace,]
#   G_2 = graph_from_data_frame(d=hrany_2, vertices=uzly, directed=F) 
#   cs = components(G_2, mode="weak")  # weak pro neorientovane grafy 
#   #cs$no  # pocet komponent 
#   vec = c(cs$no, length(blokace) / nh)#, centra) 
#   res = rbind(res, vec) 
# }

# 



# https://cran.r-project.org/web/packages/dequer/README.html