# 2022.02.: 22, 

# Kreator 
# Vytvori souvislou rovinnou sit. 
# Takova sit je aproximaci silnicni site bez tunelu a mostu. 



library(RTriangle)
library(igraph)

# p <- pslg(P=rbind(c(0, 0), c(0, 1), c(0.5, 0.5), c(1, 1), c(1, 0)))
# plot(p)
# 
# tp <- triangulate(p)
# plot(tp)
# tp$E    # Hrany triangulace 

# pocet uzlu pred redukci 
N = 16000 

x = runif(N)
y = runif(N)
xy = cbind(x,y)
#plot(xy)
p = pslg(P=xy)
#plot(p)
tp = triangulate(p)
plot(tp, pch=".")

# Uzly ponecham zatim vsechny. 
# Rozpoznam vsechny uzke trojuhelniky, 
#  z kazdeho si ulozim index nejdelsi hrany, 
# Smazu vsechny oznacene hrany. 

hrany = tp$E
trouh = tp$T

#trouh[1,]   # trojice indexuu uzluu 

idDlouhychHran = c() 
for(t in 1:dim(trouh)[1]){
  xy1 = xy[trouh[t,1],] 
  xy2 = xy[trouh[t,2],] 
  xy3 = xy[trouh[t,3],] 
  abc = c(norm(xy1-xy2,"2"), norm(xy2-xy3,"2"), norm(xy3-xy1,"2")) 
  if(min(abc)/max(abc) < 0.4){
    i = which.max(abc) 
    if(i==3){j=3; k=1} else {j=i; k=i+1} 
    i = which((hrany[,1]==trouh[t,j] & hrany[,2]==trouh[t,k]) | 
                (hrany[,1]==trouh[t,k] & hrany[,2]==trouh[t,j])) 
    idDlouhychHran = c(idDlouhychHran, i) 
  }
}

hrany2 = hrany[-idDlouhychHran,]
q = pslg(P=xy, S=hrany2) 
plot(q, pch=".")
# OK to chci. Od ted hrany2. 



# Ted odebereme nekolik uzlu z nejhustejsich mist. 
# Vytvorme sachovnici 8x8. Spocitame pocty uzluu 
#  v jednotlivych polich. 
# Z poli osidlenych husteji, nez je stredni ocekavana hustota, 
#  odebereme nahodne po jednom uzlu z kazdeho. 
# Spolu s nimi odebereme take incidentni hrany. 

d = 1/8
pritomen = rep(TRUE,dim(xy)[1])
freq = matrix(data=N,nrow=8,ncol=8,byrow=T)
nad = (freq > N/64) 
navicIds = c() 

while(any(nad)){
  offset = (d/2)*runif(1) - d/4
  bnds = seq(0 + offset, 1 + offset, d)
  for(i in 1:8){
    for(j in 1:8){
      freq[i,j] = sum((bnds[i] < xy[,1]) & (xy[,1] <= bnds[i+1]) & 
                        (bnds[j] < xy[,2]) & (xy[,2] <= bnds[j+1]) & pritomen) 
    }
  }
  nad = (freq > N/64) 
  for(i in 1:8){
    for(j in 1:8){
      if(nad[i,j]){
        ids = which((bnds[i] < xy[,1]) & (xy[,1] <= bnds[i+1]) & 
                      (bnds[j] < xy[,2]) & (xy[,2] <= bnds[j+1]) & pritomen)
        navicIds = c(navicIds, sample(ids,1)) 
      }
    }
  }
  # tyto uzly odstranit az nakonec, zatim jen ulozit 
  pritomen[navicIds] = FALSE
}

#sum(pritomen)
#points(xy[navicIds,],col="red")


navicHra = which((hrany2[,1] %in% navicIds) | (hrany2[,2] %in% navicIds)) 
uzly_id = t(t(1:N))
cooruzly = cbind(xy,uzly_id)
cooruzly = cooruzly[-navicIds,]
hrany3 = hrany2[-navicHra,]
xy3 = cooruzly[,1:2]
uzly3 = cooruzly[,3]

# prejmenovani: 
for(i in 1:length(uzly3)){
  jmeno = uzly3[i] 
  hrany3[hrany3[,1]==jmeno, 1] = i 
  hrany3[hrany3[,2]==jmeno, 2] = i 
  uzly3[i] = i 
}

q = pslg(P=xy3, S=hrany3) 
plot(q, pch=".")
# Vzniklo tam par drobnych komponent, 
# tak ty odstranit a ponechat jen tu nejvetsi. 

uzly3 = as.data.frame(uzly3)
names(uzly3) = c("id")
hrany3 = as.data.frame(hrany3)
names(hrany3) = c("uzel1", "uzel2")
G = graph_from_data_frame(d=hrany3, vertices=uzly3, directed=F) 
cs = components(G, mode="weak")

uzlyIdVNejvetsiKomponente = 1:length(uzly3$id)
if(cs$no > 1){
  uzlyIdVNejvetsiKomponente = which(cs$membership == which.max(cs$csize)) 
  spravneHra = which((hrany3[,1] %in% uzlyIdVNejvetsiKomponente) 
                     | (hrany3[,2] %in% uzlyIdVNejvetsiKomponente)) 
  hrany3 = hrany3[spravneHra,] 
  uzly3 = 1:length(uzlyIdVNejvetsiKomponente) 
  xy3 = xy3[uzlyIdVNejvetsiKomponente,] 
  # dalsi prejmenovani: 
  for(i in 1:length(uzlyIdVNejvetsiKomponente)){
    jmeno = uzlyIdVNejvetsiKomponente[i] 
    hrany3[hrany3[,1]==jmeno, 1] = i 
    hrany3[hrany3[,2]==jmeno, 2] = i 
  }
}

q = pslg(P=xy3, S=hrany3) 
plot(q, pch=".")


# Pocet obyvatel 
puzl = length(uzlyIdVNejvetsiKomponente)
obyvatel = floor(4^rexp(puzl,1))-1
id = uzly3
uzly3 = cbind(uzly3, obyvatel)
uzly3 = as.data.frame(uzly3)
names(uzly3) = c("id","obyvatel")


# Delky hran v sekundach (prumer ~ 120s) 
etalon = 0.01 
sekund = c() 
for(i in 1:(dim(hrany3)[1])){
  delka = norm(xy3[hrany3$uzel1[i],] - xy3[hrany3$uzel2[i],], "2")
  cas = (delka / etalon) * 120 * (1 + 0.8*runif(1))
  sekund = c(sekund, ceiling(cas)) 
}
hrany3 = cbind(hrany3, sekund)

G = graph_from_data_frame(d=hrany3, vertices=uzly3, directed=F) 
plot(G, vertex.size=2, vertex.label=NA, layout=xy3) 
# plot(G, vertex.size=2, vertex.label=NA, layout=xy3, 
#      xlim=c(0, 1), ylim=c(-.7, 1)) 


# adresare, data obecne a data uzlu a hran 
dataDir = "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data"
dataOut = paste(dataDir,"matice",sep="/") 
uzlyDest = paste(dataOut,"03uzly",sep="/") 
hranyDest = paste(dataOut,"03hrany",sep="/") 
poziceDest = paste(dataOut,"03xy",sep="/") 



save = function(data, typuh, nazev){
  if (typuh=="uzly"){
    kmen = uzlyDest 
  } else if (typuh=="hrany"){
    kmen = hranyDest 
  } else if (typuh=="pozice"){
    kmen = poziceDest
  }
  kam = paste(kmen,nazev,sep = "/")
  write.table(data, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = TRUE) 
}


#nazev = "nezeme00_.txt" 
#save(uzly3, "uzly", nazev) 
#save(hrany3, "hrany", nazev) 
#save(xy3, "pozice", nazev) 

#





