# 2022.02.: 23, 

# situace.R  
# Vygeneruje data pro vsechny ulohy, ktere budu resit. 

# # Vysvetlivky 
# blokace = res[[1]]      # indexy do puvodniho hrany 
# doby_oprav = res[[2]]   # stejne dlouhe jako blokace 
# start_ids = res[[3]]    # indexy do puvodniho uzly 
# uCG = res[[4]]          # indexy do puvodniho uzly 
# hCG = res[[5]]          # (uid1, uid2, casJizdy) id puvodnich uzlu 
# Casy = res[[6]]         # od kazdeho uCG ke kazdemu uCG 
# SPaths = res[[7]]       # ids uzlu cest od all uCG k all uCG 

setwd("C:/Users/acer/workspace_R/OPRBRN/003") 

library(igraph) 
library(dequer)
library(stringr)



# Ukladaci funkce 
dejCastCesty = function(dataName, pocetTymu, nc){
  sit = paste("s",str_extract_all(dataName, "\\d\\d\\d")[[1]],sep="") 
  if(pocetTymu<10){pad="0"}else{pad=""}
  tymu = paste("t",pad,as.character(pocetTymu),sep="") 
  komponent = paste("k",as.character(nc),sep="") 
  castCesty = paste(sit, tymu, komponent, sep="/") 
  return(castCesty)
}
saveBlokace = function(res, specData){
  blokace = res[[1]] 
  blokace = t(t(blokace)) 
  nazev = "blokace.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(blokace, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = FALSE) 
}
saveDobyOprav = function(res, specData){
  doby_oprav = res[[2]] 
  doby_oprav = t(t(doby_oprav)) 
  nazev = "doby_oprav.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(doby_oprav, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = FALSE) 
}
saveStartIds = function(res, specData){
  start_ids = res[[3]] 
  start_ids = t(t(start_ids)) 
  nazev = "starty.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(start_ids, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = FALSE) 
}
saveUzlyCG = function(res, specData){
  uCG = res[[4]] 
  id = t(t(uCG))
  uCG = as.data.frame(id)
  names(uCG) = "id"
  nazev = "uzlyCG.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(uCG, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = TRUE) 
}
saveHranyCG = function(res, specData){
  hCG = res[[5]] 
  hCG = as.data.frame(hCG)
  names(hCG) = c("uzel1","uzel2","sekund")
  nazev = "hranyCG.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(hCG, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = TRUE) 
}
saveCasy = function(res, specData){
  Casy = res[[6]] 
  nazev = "casyCG.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(Casy, kam, append = FALSE, sep = ", ", 
              dec = ".", row.names = FALSE, col.names = FALSE) 
}
saveSPaths = function(res, specData){
  SPaths = res[[7]] 
  nazev = "nejrychlejsiCesty.txt" 
  kam = paste(outDirKmen, specData, nazev, sep = "/") 
  for(i in 1:length(SPaths)){
    write(SPaths[[i]], file=kam, ncolumns=length(SPaths[[i]]), 
          append = TRUE, sep = " ") 
  }
}
saveKompId = function(res, specData){
  uKompId = res[[8]] 
  uKompId = t(t(uKompId)) 
  nazev = "uKompId.txt"
  kam = paste(outDirKmen, specData, nazev, sep = "/")
  write.table(uKompId, kam, append = FALSE, sep = " ", 
              dec = ".", row.names = FALSE, col.names = FALSE) 
}
save = function(res, specData){
  saveBlokace(res, specData)
  saveDobyOprav(res, specData)
  saveStartIds(res, specData)
  saveUzlyCG(res, specData)
  saveHranyCG(res, specData)
  saveCasy(res, specData)
  saveSPaths(res, specData)
  saveKompId(res, specData)
}

# Puvod zdroje.R, destruktor.R 
hlavniFunkce = function(uzly, hrany, pozice, centra, pocetTymu){
  nu = dim(uzly)[1] 
  nh = dim(hrany)[1] 
  G = graph_from_data_frame(d=hrany, vertices=uzly, directed=F) 
  getSousedi = function(id_uzlu){
    return( as.vector(neighbors(G, id_uzlu, mode="all")) )
  }
  getOkoli = function(id_uzlu){
    return( as.vector(incident(G, id_uzlu, mode="all")) )
  }
  novaBarvaHrany = function(barvaUzlu1, barvaUzlu2){
    if((barvaUzlu1<0) && (barvaUzlu2<0)){return(-1)}
    if((barvaUzlu1<0) && (barvaUzlu2>0)){return(barvaUzlu2)}
    if((barvaUzlu1>0) && (barvaUzlu2<0)){return(barvaUzlu1)}
    if((barvaUzlu1>0) && (barvaUzlu2>0)){
      if(barvaUzlu1!=barvaUzlu2){return(0)}
      else{return(barvaUzlu1)}
    }
  }
  dejBlokace = function(uzly, hrany, centra){
    # Inicializace 
    labU = rep(-1, nu)   # -1 ~ neoznaceny uzel 
    labH = rep(-1, nh)   # -1 ~ neoznacena hrana 
    frontySousedu = list()
    for(k in 1:nc){
      labU[centra[k]] = centra[k]
      frontySousedu[[k]] = queue()
      pushback(frontySousedu[[k]], centra[k])
    }
    # Rozpinani center po uzlech site (barveni uzlu) 
    podminka = TRUE 
    while(podminka){
      for(k in 1:nc){
        ff = frontySousedu[[k]]
        uid = pop(ff)
        suids = getSousedi(uid)
        if(length(suids)>0){
          novi = suids[(labU[suids]==-1)]
          if(length(novi)>0){
            labU[novi] = centra[k] ##
            for(i in 1:length(novi)){
              pushback(ff,novi[i]) 
            }
          }
        }
      }
      podminka = FALSE 
      for(k in 1:nc){ podminka = podminka || (length(frontySousedu[[k]])>0) } 
    }
    # Barveni hran 
    for(i in 1:nh){
      labH[i] = novaBarvaHrany(labU[hrany[i,1]], labU[hrany[i,2]]) 
    }
    blokace = which(labH==0)
    return(blokace)
  }
  
  blokace = dejBlokace(uzly, hrany, centra)
  doby_oprav = 10*sample(hrany$sekund, length(blokace)) 
  start_ids = sample(uzly$id, pocetTymu, replace=T) 
  # V jednom uzlu muze byt vice cestarskych tymu 
  # Vodakovo zuplneni site  # CG = (BC, SP), CG = (uCG, hCG) 
  uCG = union(hrany$uzel1[blokace], hrany$uzel2[blokace]) 
  uCG = union(uCG, start_ids) 
  hCG = c()   # (uzel1, uzel2, sekund) 
  SP = list() # SP[[k]] = vektor uzluu nejkratsi cesty od hCG[k,1] do hCG[k,2] 
  Casy = distances(G, v=uCG, to=uCG, mode=c("all"), 
                   weights=hrany$sekund, algorithm=c("dijkstra")) 
  SP = list()
  for(i in 1:(length(uCG)-1)){
    sp = shortest_paths(G, from=uCG[i], to=uCG[(i+1):length(uCG)], 
                        mode=c("all"), weights=hrany$sekund,
                        output = "vpath", predecessors = FALSE, 
                        inbound.edges = FALSE) 
    SP[[i]] = sp 
  }
  # Tvorba hran hCG noveho (a uplneho) grafu CG 
  k = 1 
  SPaths = list() 
  for(i in 1:(length(uCG)-1)){
    for(j in (i+1):length(uCG)){
      path = SP[[i]]$vpath[[(j-i)]]
      hCG = rbind(hCG, c(uCG[i], uCG[j], Casy[i,j])) 
      SPaths[[k]] = as.vector(path) 
      k = k+1 
    }
  }
  # Prislusnost uzlu ke komponentam rozpadle site 
  hranyDestr = hrany[-blokace,] 
  GDestr = graph_from_data_frame(d=hranyDestr, vertices=uzly, directed=F) 
  cs = components(GDestr, mode="weak")
  uKompId = cs$membership 
  # vysledky 
  res = list() 
  res[[1]] = blokace 
  res[[2]] = doby_oprav 
  res[[3]] = start_ids 
  res[[4]] = uCG 
  res[[5]] = hCG 
  res[[6]] = Casy 
  res[[7]] = SPaths 
  res[[8]] = uKompId 
  return(res) 
}





# Hlavni prace: 
inDirKmen = "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data/matice"
outDirKmen = "C:/Users/acer/Documents/MaTemata/Prace/KvalifikacniPrace/Diplomka/data/situace"
dataNameS = c("nezeme001.txt", "nezeme002.txt")
poctyCenter = c(10,20,40) 
for(i in 1:2){ 
  dataName = dataNameS[i]
  uzly = read.csv(paste(inDirKmen, "03uzly", dataName, sep="/"), sep="") 
  hrany = read.csv(paste(inDirKmen, "03hrany", dataName, sep="/"), sep="") 
  pozice = read.csv(paste(inDirKmen, "03xy", dataName, sep="/"), sep="") 
  if(i==1){
    poctyTymu = c(2,3,4) 
  }else{
    poctyTymu = c(5,6,7) 
  }
  for(j in 1:3){
    pocetTymu = poctyTymu[j] 
    for(k in 1:3){
      nc = poctyCenter[k] 
      centra = sample(dim(uzly)[1], nc) 
      res = hlavniFunkce(uzly, hrany, pozice, centra, pocetTymu) 
      specData = dejCastCesty(dataName, pocetTymu, nc)
      save(res, specData)  ### TERMINAL 
    }
  }
}





