# 2022.02.: 20, 22 

# Zdroje 

# Vstupni sit necht je souvisla. 
# Destruktor nam vygeneroval vyber hran k blokaci. 
# Jejich uzavrenim (odebranim) se sit rozpadne na komponenty souvislosti. 

# Tento skript: 
# - ohodnoti zablokovane hrany dobou oprav v sekundach. 
# - do vybranych uzlu umisti silnicarske cety 
# - vytvorime novou sit - uplny graf nad hranicnimi uzly rozpadle site 

# A subset B subset R:         # m.m.h. ~ minimalni mnozina hran 
# R - mnozina vsech rozbitych silnic; po nekterych R zustava sit souvisla 
#  Dale uvazujme vsechna R zodpovedna za destrukci site G. 
# B - m.m.h., jejichz blokace zpusobi zmenu G na nesouvislou G'. 
#  Pozor! B nemusi byt nejmensi, je jen ("lokalne") minimalni. 
# A - m.m.h. kt. staci odblokovat, aby se G' zmenila na souvislou G''. 
#  Tohle A neni urceno jednoznacne. 
#  Reseni rozklada A mezi m cestarskych cet. 



# Potrebne vstupy:                              ### << IN 

# # vygeneruje k dane siti pokazde jine komponenty
# source("C:/Users/acer/workspace_R/OPRBRN/003/destruktor.R") 

# nahraje k dane siti pokazde tytez komponenty 
wpdir = "C:/Users/acer/workspace_R/OPRBRN/003/wspchpt" 
rdatafile = "KV_nepo_20komp_01.RData" 
load(paste(wpdir, rdatafile, sep="/")) 
rm(wpdir, rdatafile) 
library(igraph) 
library(dequer)



# blokace ziskam z destruktor.R 
doby_oprav = 10*sample(hrany$sekund, length(blokace)) 

# m je pocet cestarskych tymu (v jednom uzlu jich muze byt vice) 
m = 4                                           ### << IN 
start_ids = sample(uzly$id, m, replace=T) 

# Vodakovo zuplneni site  # CG = (BC, SP), CG = (uCG, hCG) 
uCG = union(hrany$uzel1[blokace], hrany$uzel2[blokace]) 
uCG = union(uCG, start_ids) 
hCG = c()   # (uzel1, uzel2, sekund) 
SP = list() # SP[[k]] = vektor uzluu nejkratsi cesty od hCG[k,1] do hCG[k,2] 
# for(i in 1:(length(uCG)-1)){
#   for(j in (i+1):length(uCG)){
#     # (uCG[i], uCG[j]): 
#     # - nejkratsi casova vzdalenost 
#     # - nejkratsi casova cesta 
#   }
# }
Casy = distances(G, v=uCG, to=uCG, mode=c("all"), 
          weights=hrany$sekund, algorithm=c("dijkstra")) 
SP = list()
for(i in 1:(length(uCG)-1)){
  sp = shortest_paths(G, from=uCG[i], to=uCG[(i+1):length(uCG)], 
                 mode=c("all"), weights=hrany$sekund,
                 output = "vpath", predecessors = FALSE, 
                 inbound.edges = FALSE) 
  SP[[i]] = sp 
}

# 1) Kontrola, zda kazda z cest zacina a konci jak ma 
# 2) Tvorba hran hCG noveho (a uplneho) grafu CG 
check = TRUE 
k = 1 
SPaths = list() 
for(i in 1:(length(uCG)-1)){
  for(j in (i+1):length(uCG)){
    path = SP[[i]]$vpath[[(j-i)]]
    check = check && (path[1]==uCG[i])&&(tail(path,1)==uCG[j]) 
    hCG = rbind(hCG, c(uCG[i], uCG[j], Casy[i,j])) 
    SPaths[[k]] = as.vector(path) 
    k = k+1 
    if(check==FALSE){
      hCG = c() 
      SPaths = list() 
      break 
    }
  }
}
check

# length(SPaths)
# SPaths[[24090]]
# tail(hCG,1)
# dim(Casy)
# Casy[219,220]
# # Holaaa! Tohle funguje. 


# Vystupy (nove):                          ### << OUT 
Casy
SPaths
uCG
hCG

# Vystupy (drivejsi):                      ### << OUT 
blokace 
centra


# TODO 
# Uklidit (rm) nepotrebne promenne. 
# A zbytek asi zase nejak ulozit. 

# TODO 
# Vyzobat z tohoto potrebne kody aplikovatelne na umele rovinne site. 














