
import pomocne as pm 
import reseniM as aco 
import numpy as np 
 
vystupniAdresar = "C:\\Prilohy\\Testy\\ACOvsNahoda\\" 
poctyTymuVeStanicich = np.array([2,2]) 
parametry = aco.pripravParametry({}, pm.casyCG, poctyTymuVeStanicich) 
parametry["uzitPocatecniReseni"] = False 
parametry["iterLimit"] = 1000 
pocetOpakovani = 10 
# Proces reseni ulohy: 



def generujCenyReseni(parametry, nazev, pocetOpakovani): 
    tabulkyVsechny = [] 
    for i in range(pocetOpakovani): 
        zaznamnik = [] 
        aco.MMAS(pm.casyCG, pm.startyCG, poctyTymuVeStanicich, 
                 parametry, zaznamnik) 
        tabulkaCeny = [] 
        for r in zaznamnik: 
            dobyPraci = aco.cenyTras(r) 
            tabulkaCeny.append(pm.cenaQ3(dobyPraci)) 
        tabulkaCeny = np.array(tabulkaCeny) 
        # Ceny reseni od nejlepsi po nejhorsi. 
        (tabulkaSerazena, taidxs) = pm.mujLexSort(tabulkaCeny) 
        # Ulozime ceny prvnich tri nejlepsich reseni 
        tabulkyVsechny.append(tabulkaSerazena[0:3,:]) 
    tabulkyVsechny = np.array(tabulkyVsechny) 
    pm.ulozeni(tabulkyVsechny[:,0,:], vystupniAdresar, nazev+"_0") 
    pm.ulozeni(tabulkyVsechny[:,1,:], vystupniAdresar, nazev+"_1") 
    pm.ulozeni(tabulkyVsechny[:,2,:], vystupniAdresar, nazev+"_2") 
    pm.ulozeni(np.mean(tabulkyVsechny,axis=0), vystupniAdresar, nazev+"_means") 
    pm.ulozeni(np.std(tabulkyVsechny,axis=0), vystupniAdresar, nazev+"_stds") 
    return tabulkyVsechny 



# RAND 
parametry["aktualizovatFeromony"] = False  
parametry["alfa"] = 1 
parametry["beta"] = 0 
parametry["zlepsovaciAlgoritmus"] = 'nic'  
ts_r = generujCenyReseni(parametry, "RAND", pocetOpakovani) 

# RANDopt2 
parametry["aktualizovatFeromony"] = False  
parametry["alfa"] = 1 
parametry["beta"] = 0 
parametry["zlepsovaciAlgoritmus"] = 'opt2'  
ts_ro = generujCenyReseni(parametry, "RANDopt2", pocetOpakovani) 

# MMAS 
parametry["aktualizovatFeromony"] = True 
parametry["alfa"] = 1 
parametry["beta"] = 1 
parametry["zlepsovaciAlgoritmus"] = 'nic'  
ts_m = generujCenyReseni(parametry, "MMAS", pocetOpakovani) 

# MMASopt2 
parametry["aktualizovatFeromony"] = True 
parametry["alfa"] = 1 
parametry["beta"] = 1 
parametry["zlepsovaciAlgoritmus"] = 'opt2'  
ts_mo = generujCenyReseni(parametry, "MMASopt2", pocetOpakovani) 


